
;==========================================================	
;pack_depack_pattern_data
;RUNS OUTSIDE IRQ


pack_depack_pattern_data
	lda zp_ed_free_play_mode
	beq +
	rts
+	
;=============================
set_pattern_colour_on_off
	ldy #$0c	;noop abs
	ldx #$ea	;nop
	lda zp_ed_pattern_on_off	;get channel
	and #%10000011
	beq set_pattern_colour_on_off_exit
	bmi +
	ldy #$4a
	ldx #$4a
+	sty pat_col_opcode1
	stx pat_col_opcode2

		
	and #%00000011
	tay
	
	ldx mul7-1,y
	lda start_end_scroll_column,x	
	sta zp_ed_column
	lda start_end_scroll_column+7,x	
	sta zp_ed_colour_nybbles
	
	ldx #25-3	
-
	lda screen_row_lo+3,x
	sta zp_ed_scr_to_lo
	lda screen_row_hi+3,x
	eor #$6c 
	sta zp_ed_scr_to_hi

	ldy zp_ed_column
-	
get_pattern_colours_on_off
	lda pattern_columns_colours,y
	
pat_col_opcode1	lsr
	lsr
	lsr
pat_col_opcode2	lsr
	sta (zp_ed_scr_to_lo),y
	
	iny
	cpy zp_ed_colour_nybbles
	bcc -
	
	dex
	bpl --
	
	dec zp_ed_pattern_on_off

	bit zp_ed_pattern_on_off
	bvs set_pattern_colour_on_off
		
+	
	lda #0
	sta zp_ed_pattern_on_off
	
set_pattern_colour_on_off_exit
	
;====================================================================		
		


;check if we need to insert/delete intrument data pointers before depacking
;this takes too much time, so it's outside IRQ
;insert_backspace_intr_data_pointer
	lda zp_ed_repack_inserts
	beq pack_depack_pattern_data_skip_insert_backspace
	
	ldy zp_ed_keyboard_current
	bne pack_depack_pattern_data_skip_insert_backspace

	sta ib_inserts+1
	
	
	lda #>patterns
	sta zp_ed_scr_to_hi
	lda #<patterns
	sta zp_ed_scr_to_lo
	
-	
	ldy #0
	sty zp_ed_repack_inserts
-
	lda (zp_ed_scr_to_lo),y
	cmp #end
	beq ++
	cmp zp_ed_repack_instrument_command
	bne +
	iny
	lda (zp_ed_scr_to_lo),y
	cmp zp_ed_repack_instrument_value
	bcc +
	

insert_backspace_intr_data_pointer_add
	clc	
ib_inserts	adc #0	;zp_ed_repack_inserts
	beq +
	sta (zp_ed_scr_to_lo),y 	
+	iny
	bne -
+	
	inc zp_ed_scr_to_hi
	lda zp_ed_scr_to_hi
	cmp #>music_data_end
	bcc --
	
insert_backspace_intr_data_pointer_repack
	
	;re-depack the patterns
	ldx #$0e
-	lda #$80
	sta screen_pattern_rendered,x
	sta depacked_screen_pattern,x
	asl
	sta pack_current_screen_pattern,x	;just in case, no need to pack
	txa
	sbx #$07
	bpl -	


;====================
pack_depack_pattern_data_skip_insert_backspace
	
	
	ldx #$0e
pack_depack_pattern_data_loop

	stx zp_ed_channel_temp

;check if we need to pack in this loop	
	lda pack_current_screen_pattern,x
	bmi rerender_temporary_screen
	beq +
	ldy current_screen_pattern,x
	jsr pack_pattern
	lda #0
	sta pack_current_screen_pattern,x
	jmp pack_depack_pattern_data_end_loop
+
	lda #1
	sta zp_ed_depack_pattern_pos	;endless loop retries

	jsr get_song_patterns
	stx zp_ed_scr_to_hi
	sta zp_ed_scr_to_lo
		
	
;find first valid pattern to depack
	ldx zp_ed_channel_temp

	ldy current_editing_song_pos,x
	lda screen_pattern_rendered,x
	bne +
-	iny
+
-	
	lda (zp_ed_scr_to_lo),y
	cmp #dwn00
	bcc possible_pattern_found
	
	cmp #loop
	bcc --
		
	cmp #end
	beq possible_pattern_found+2
	iny
	lda (zp_ed_scr_to_lo),y
	tay
	dec zp_ed_depack_pattern_pos
	bpl -
	lda #0		;set pattern 0 if endless loop is detected, else player crashes
	sta (zp_ed_scr_to_lo),y 
	bcc -


possible_pattern_found
	cmp depacked_screen_pattern,x
	beq pattern_is_allready_depacked

	
	
found_pattern_to_depack
	sta depacked_screen_pattern,x
	

	jsr convert_voice_x_to_memory
	eor #$20
	tay
	and #$f0
	sta depacked_screen_pattern_bank,x
	
	jsr depack_pattern

		
rerender_temporary_screen
	lda depacked_screen_pattern_length,x
	sec
	sbc #10
	bcs poke_top_temp_screen
	
	eor #$ff
	sta zp_ed_scr_to_row_end
	adc #3
	sta zp_ed_scr_to_row

		
clear_top_temp_screen
	lda #<$e450
	sta zp_ed_scr_to_lo
	lda #>$e450
	sta zp_ed_scr_to_hi
	
clear_top_temp_screen_loop		
	ldy start_end_scroll_column,x
-	lda pattern_columns_empty,y
	ora #$20
	sta (zp_ed_scr_to_lo),y
	iny
	tya
	cmp start_end_scroll_column+7,x
	bcc -

	lda zp_ed_scr_to_lo
	adc #$27
	sta zp_ed_scr_to_lo
	bcc +
	inc zp_ed_scr_to_hi
+	
	dec zp_ed_scr_to_row_end	
	bpl clear_top_temp_screen_loop
	
	
	anc #0
	
	
poke_top_temp_screen	
	sta zp_ed_scr_from_lo	;index
	bcc + 
	lda #2
	sta zp_ed_scr_to_row	;start screen row
+	lda #$30		;poke top part to temporary screen
	sta zp_ed_scr_to_buffer
	lda #12
	sta zp_ed_scr_to_row_end
	ldy zp_ed_channel_temp
	ldx #0
	jsr screen_pattern_data
			

poke_bottom_temp_screen	
	stx zp_ed_scr_from_lo
	jsr set_max_start_end_row_pattern_screen
	ldy zp_ed_channel_temp
	jsr screen_pattern_data

	
	
	
	ldx zp_ed_channel_temp
	
pattern_is_allready_depacked	
	
	lda screen_pattern_rendered,x
	and #%10000000
	beq pattern_is_allready_rendered
			;poke bottom part + clear top part
	jsr copy_screen_buffer_bottom

	
	lda screen_pattern_rendered,x
	eor #%10000001
	sta screen_pattern_rendered,x
	
	
pattern_is_allready_rendered			


	lda current_screen_pattern,x
	bpl +
	lda #0
	sta zp_ed_scr_nybble_lo
	beq ++	
+	
	jsr convert_byte_to_text
	
+
	ldy start_end_scroll_column+7,x	
	sta $b421+40,y
	lda zp_ed_scr_nybble_lo
	sta $b422+40,y
	
	lda screen_pattern_length,x
	bpl +
	lda #0
	sta zp_ed_scr_nybble_lo
	beq ++	
+	
	ldx #0
	jsr convert_byte_to_decimal_text_scr
	tya
+	
	ldx zp_ed_channel_temp
	ldy start_end_scroll_column+7,x
	sta $b426+40,y
	lda zp_ed_scr_nybble_lo
	sta $b427+40,y


	lda pack_current_screen_pattern,x	
	and #$7f
	sta pack_current_screen_pattern,x	
pack_depack_pattern_data_end_loop	
	txa	
	sbx #7
	bmi +
	jmp pack_depack_pattern_data_loop
	
	
+
	rts
	

scroll_insert_pattern_loop	
	
	lda $b798,y
scroll_pat_down	sta $b7c0,y
	lda $b770,y
	sta $b798,y
	lda $b748,y
	sta $b770,y
	lda $b720,y
	sta $b748,y
	lda $b6f8,y
	sta $b720,y
	lda $b6d0,y
	sta $b6f8,y
	lda $b6a8,y
	sta $b6d0,y
	lda $b680,y
	sta $b6a8,y
	lda $b658,y
	sta $b680,y
	lda $b630,y
	sta $b658,y
	lda $b608,y
	sta $b630,y
	lda $b5e0,y
	sta $b608,y
	lda (zp_ed_scr_from_lo+2),y
	sta $b5e0,y
	iny
	cpy zp_ed_scr_to_row+2
	bcc scroll_insert_pattern_loop
	rts
	
scroll_insert_pattern_opcodes	
;poke opcodes to skip end of pattern refresh	
	ldx #0
-
	lda #$99	;sta abs,y
insert_pat_skip	cpy zp_ed_scr_temp+2
	bcc +
	lda #$0c	;noop abs
+	sta scroll_pat_down,x
	dey
	txa
	sbx #$fa
	cpx #6*12
	bcc -
	rts	
	
		
scroll_back_pattern_loop	
	lda $b608,y
scroll_pat_up	sta $b5e0,y
	lda $b630,y
	sta $b608,y
	lda $b658,y
	sta $b630,y
	lda $b680,y
	sta $b658,y
	lda $b6a8,y
	sta $b680,y
	lda $b6d0,y
	sta $b6a8,y
	lda $b6f8,y
	sta $b6d0,y
	lda $b720,y
	sta $b6f8,y
	lda $b748,y
	sta $b720,y
	lda $b770,y
	sta $b748,y
	lda $b798,y
	sta $b770,y
	lda $b7c0,y
	sta $b798,y
	iny
	cpy zp_ed_scr_to_row+2
	bcc scroll_back_pattern_loop
	rts
	
scroll_back_pattern_opcodes	
;poke opcodes to skip end of pattern refresh	
	ldx #6*11
-
	lda #$99	;sta abs,y
back_pat_skip	cpy zp_ed_scr_temp+2
	bcc +
	lda #$0c	;noop abs
+	sta scroll_pat_up,x
	dey
	txa
	sbx #6
	bpl -
	rts
	
	
;==========================================================
;scroll_pattern_data
;IRQ
;in: x = channel (0,$07,$0e)
;in: a = direction (0=up,1=down)
scroll_pattern_data_init_down
	lda #1	
scroll_pattern_data
	stx zp_ed_channel_temp+2

	ldy #<$b7c0
	sty zp_ed_scr_to_lo+2	
	sty zp_ed_scr_temp+2
	
	ldy #>$b7c0
	sty zp_ed_scr_to_hi+2	

			
	ldy #<$b5b8
	sty zp_ed_scr_from_lo+2
	ldy #>$b5b8
	sty zp_ed_scr_from_hi+2

		
	lsr
	bcc scroll_pattern_data_up
	
scroll_pattern_data_down

	jsr scroll_insert_pattern_opcodes
		
	jsr init_pattern_scroll_back_insert_
;	ldx zp_ed_channel_temp+2
	
;	ldy start_end_scroll_column+7,x
;	sty zp_ed_scr_to_row+2
	ldy start_end_scroll_column,x
	
	jsr scroll_insert_pattern_loop
	
	ldy start_end_scroll_column,x
-	
	lda $b590,y
	sta $b5b8,y
	lda $b568,y
	sta $b590,y
	lda $b540,y
	sta $b568,y
	lda $b518,y
	sta $b540,y
	lda $b4f0,y
	sta $b518,y
	lda $b4c8,y
	sta $b4f0,y
	lda $b4a0,y
	sta $b4c8,y
	lda $b478,y
	sta $b4a0,y

	iny
	cpy zp_ed_scr_to_row+2
	bcc -
	
	txa
	pha
	tay

	lda #<$b478
	sta zp_ed_scr_to_lo+2
	lda #>$b478
	sta zp_ed_scr_to_hi+2
	
	dec screen_pattern_position,x
	lda screen_pattern_position,x
	sbc #21	
	bcc scroll_pattern_clear_line
+	ldx #3
	bcs scroll_pattern_screen_line
	
	
;-----------------------------		
scroll_pattern_data_up

	jsr scroll_back_pattern_opcodes

	ldx zp_ed_channel_temp+2
	
	lda start_end_scroll_column+7,x
	sta zp_ed_scr_to_row+2
	
	ldy start_end_scroll_column,x
-	
	lda $b4a0,y
	sta $b478,y
	lda $b4c8,y
	sta $b4a0,y
	lda $b4f0,y
	sta $b4c8,y
	lda $b518,y
	sta $b4f0,y
	lda $b540,y
	sta $b518,y
	lda $b568,y
	sta $b540,y
	lda $b590,y
	sta $b568,y
	lda $b5b8,y
	sta $b590,y
	lda $b5e0,y
	sta $b5b8,y
	iny
	cpy zp_ed_scr_to_row+2
	bcc -	

	ldy start_end_scroll_column,x
	
	jsr scroll_back_pattern_loop
	
	txa
	pha
	tay

	inc screen_pattern_position,x
	
	lda screen_pattern_position,x
	cmp screen_pattern_length,x
	bcs scroll_pattern_clear_line
	
	ldx #24	
scroll_pattern_screen_line	
	sta zp_ed_scr_from_lo+2
	lda #0		;poke directly to screen
	sta zp_ed_scr_to_buffer+2
	stx zp_ed_scr_to_row+2
	stx zp_ed_scr_to_row_end+2
	ldx #2
	jsr screen_pattern_data
	jmp scroll_pattern_return_x	;jmp scroll_pattern_return_x

scroll_pattern_clear_line	
	ldy start_end_scroll_column,x
-	lda pattern_columns_empty,y
	ora #$20
	sta (zp_ed_scr_to_lo+2),y
	iny
	cpy zp_ed_scr_to_row+2
	bcc -	
scroll_pattern_return_x	
	pla
	tax
	rts

copy_screen_buffer_init
	

					
;---------------------	
copy_screen_buffer_top
	txa
	pha

	lda start_end_scroll_column+7,x
	sta zp_ed_scr_to_row+2
	clc
	adc #80
	sta zp_ed_scr_to_row_end+2
	
	lda start_end_scroll_column,x
	sta zp_ed_scr_from_row+2
	sta zp_ed_scr_from_lo+2
	tax
	tay

-
	lda $e450,x
	sta $b478,x	

	lda $e4c8,x
	sta $b4f0,x
	
	lda $e540,x
	sta $b568,x
	
	lda $e5b8,y
	sta $b5e0,y

	lda pattern_columns_empty,y
	ora #$20
	sta $b608,x
	sta $b680,x
	sta $b6f8,x
	sta $b770,x
	
	inx						
	iny
	cpy zp_ed_scr_to_row+2
	bcc - 

	lax zp_ed_scr_from_lo+2
	sbx #$d8
	stx zp_ed_scr_from_lo+2
	cpx zp_ed_scr_to_row_end+2
	ldy zp_ed_scr_from_row+2
	bcc -
	
	jmp scroll_pattern_return_x
	
	
;------------------------------------
		
copy_screen_buffer_bottom
;x=channel

	lda start_end_scroll_column+7,x
	sta csbb+1
	
	ldy start_end_scroll_column,x
		

-
	lda pattern_columns_empty,y
	ora #$20
	sta $b478,y
	sta $b478+40,y
	sta $b478+80,y
	
	sta $b4f0,y
	sta $b4f0+40,y
	sta $b4f0+80,y
	
	sta $b568,y
	sta $b568+40,y
	sta $b568+80,y
		
	
	lda $e5e0,y
	sta $b5e0,y	
	lda $e5e0+40,y
	sta $b5e0+40,y	
	lda $e5e0+80,y
	sta $b5e0+80,y	

	lda $e658,y
	sta $b658,y
	lda $e658+40,y
	sta $b658+40,y
	lda $e658+80,y
	sta $b658+80,y

	lda $e6d0,y
	sta $b6d0,y
	lda $e6d0+40,y
	sta $b6d0+40,y
	lda $e6d0+80,y
	sta $b6d0+80,y

	lda $e748,y
	sta $b748,y
	lda $e748+40,y
	sta $b748+40,y
	lda $e748+80,y
	sta $b748+80,y
				
	lda $e7c0,y
	sta $b7c0,y
	iny						

csbb	cpy #0
	bcs +
	jmp - 
	
+
	
	
copy_depacked_pattern_to_current	
	lda #12
	sta screen_pattern_position,x
			
	lda depacked_screen_pattern_length,x
	sta screen_pattern_length,x
	lda depacked_screen_pattern,x
	sta current_screen_pattern,x
	lda depacked_screen_pattern_bank,x
	sta screen_pattern_bank,x
	rts

copy_screen_line_to_temp_screen
	;a=row on temp screen
	tax
	jsr init_io_ram
	
	lda screen_row_lo,x
	sta screen_line_to+1
	
	lda screen_row_hi,x
	eor #$50		;always to temp screen
	sta screen_line_to+2
	
	;y=channel 0/7/e
	lda start_end_scroll_column+7,y
	sta screen_line_end+1
	
	ldx start_end_scroll_column,y

-	lda $b5e0,x
screen_line_to	sta $e400,x
	inx
screen_line_end	cpx #0
	bcc -
	jmp return_io
	
;==========================================================
;pack_pattern
;in: Y = pattern to depack
;in: X = channel (0,7,14)
;depack prg
;0000=instrument (5 low-bits) \/ glide type (3 hi-bits)
;0080=note/gate \/ $80 end marker
;0100=prgads value
;0180=prgpor value / glide value
;0200=prgwav value
;0280=prgfre value
;0300=prgpul value
;0380=prgfil value
;0400=prghar value ;3 hi-bits free
;0480=speed value \/ $80 sets marker for pattern cmd used

;pack order:speed,val,instr,dur,prgads,val,prgwav,val,prgfre,val,prgpul,val,prgfil,val,prghar,val,prgpor,val,glide,0,note`
pack_pattern_exit
	ldy zp_ed_depack_pattern_pos
	lda #end
	sta (zp_ed_scr_to_lo),y
	iny
	lda #0
-	sta (zp_ed_scr_to_lo),y	
	iny
	bne -
	ldx zp_ed_channel_temp	
	jmp return_io

pack_pattern
	;dec $d020
	jsr init_io_ram
	
	jsr convert_voice_x_to_memory
	sta zp_ed_scr_nybble_hi

	lda #$00
	sta zp_ed_scr_nybble_lo
	sta zp_ed_scr_from_lo
	sta zp_ed_depack_row
	sta zp_ed_scr_temp	;instrument buffer
	sta zp_ed_scr_column	;glide temp
	sta zp_ed_scr_to_row_end	;note/gate temp
	sta zp_ed_depack_pattern_pos

	lda #$ff
	sta zp_ed_depack_dur_buffer	;dur buffer
			
	lda patterns_lo,y
	sta zp_ed_scr_to_lo
	lda patterns_hi,y
	sta zp_ed_scr_to_hi

pack_pattern_loop
	;first check for end marker
	ldx #$80
	stx zp_ed_scr_nybble_prehi
	
	jsr fetch_data_to_pack_from_memory
	bmi pack_pattern_exit
	
pack_pattern_note
	sta zp_ed_scr_to_row_end	;set note/gateoff
	
	;check for speed command
	ldx #$84
	jsr fetch_data_to_pack_from_memory
	asl
	rol zp_ed_scr_nybble_prehi	;shift carry in for dur check
	lsr
	and #$7f
	beq pack_speed_done
	sta zp_ed_scr_to_row
	lda #speed
	jsr set_packed_data_to_memory_double
	
pack_speed_done
	;check for instrument and compare with buffer
	ldx #$00
	jsr fetch_data_to_pack_from_memory
	sta zp_ed_scr_column
	and #$1f
	beq pack_instrument_done
	cmp zp_ed_scr_temp
	beq pack_instrument_done
	sta zp_ed_scr_temp
	ora #ins00
	jsr set_packed_data_to_memory
		
pack_instrument_done	
	;inner loop for dur value and compare with dur buffer
	lda #$80
	sta zp_ed_scr_from_lo
	sta zp_ed_scr_from_row	;is also lobyte of nybble_prehi
	lda zp_ed_scr_nybble_hi
	sta zp_ed_scr_from_hi	
	clc
	adc #4
	sta zp_ed_scr_nybble_prehi
	
	ldx #0
	ldy zp_ed_depack_row
-	iny
	lda (zp_ed_scr_from_row),y	;get command
	and #$80
	ora (zp_ed_scr_from_lo),y	;
	ora (zp_ed_scr_nybble_lo),y
	bne pack_new_note_gate_or_end_marker_found
	inx
	cpx #$60		
	bcc -
	
	;ldx #$5f	;max dur in musicroutine
		
pack_new_note_gate_or_end_marker_found

	cpx zp_ed_depack_dur_buffer
	beq pack_dur_done	
	stx zp_ed_depack_dur_buffer
	txa
	ora #dur00
	jsr set_packed_data_to_memory
	
pack_dur_done	
	lda #prgads
	sta zp_ed_scr_from_row
	
	;check commands low 
	ldx #$01
pack_command_loop	
	jsr fetch_data_to_pack_from_memory
	beq pack_command_low_done
	jsr set_packed_data_to_memory_command
	
pack_command_low_done
	inc zp_ed_scr_from_row

	cpx #$04		;till speed command
	bcs pack_command_done

	cpx #1
	bne +
	lda zp_ed_scr_column
	and #%11100000
	beq +
	cmp #%10100000		;bits for tienote
	bne pack_command_high_done	
	
+
	txa
	ora #$80
	tax
	;check commands high
	jsr fetch_data_to_pack_from_memory
	beq pack_command_high_done
	jsr set_packed_data_to_memory_command
	
pack_command_high_done
	inc zp_ed_scr_from_row

	txa
	anc #$7f
	tax
	inx
	bcc pack_command_loop
	
pack_command_done

	;check for glide commands
	lda zp_ed_scr_column
	and #%11100000
	beq pack_glide_done
	lsr
	lsr
	lsr
	lsr
	lsr
	ora #$e0
	jsr set_packed_data_to_memory
	cmp #tie
	beq pack_glide_done
	
	ldx #$81
	jsr fetch_data_to_pack_from_memory
	jsr set_packed_data_to_memory
	
		
pack_glide_done	
	;check for gate command
	lda zp_ed_scr_to_row_end
	;and #$7f
	cmp #gateoff-128
	bcc pack_gate_done
	ora #$e0
	jsr set_packed_data_to_memory
	
	lda #nonote	
pack_gate_done		

	jsr set_packed_data_to_memory
	
	lda zp_ed_depack_row
	sec
	adc zp_ed_depack_dur_buffer
	sta zp_ed_depack_row
	jmp pack_pattern_loop
	
	
;===================	
fetch_data_to_pack_from_memory
	txa
	and #$80
	sta zp_ed_scr_from_lo
	txa
	anc #$07
	adc zp_ed_scr_nybble_hi
	sta zp_ed_scr_from_hi
	ldy zp_ed_depack_row
	lda (zp_ed_scr_from_lo),y
	rts
	
set_packed_data_to_memory_command	
	sta zp_ed_scr_to_row
	lda zp_ed_scr_from_row	
set_packed_data_to_memory_double
	ldy zp_ed_depack_pattern_pos
	sta (zp_ed_scr_to_lo),y
	iny 	
	lda zp_ed_scr_to_row
	.byte $0c
set_packed_data_to_memory
	ldy zp_ed_depack_pattern_pos	
	sta (zp_ed_scr_to_lo),y
	iny
	sty zp_ed_depack_pattern_pos
	rts	
;==========================================================
;depack_pattern
;in: Y = pattern to depack
;in: X = channel (0,7,14)

;nonote=$00
;c0 = $01
;ins00 = $60
;dur00 = $80
;gateoff = $e0	
;gateon = $e1
;speed = $e2	
;gliup = $e3
;glido = $e4
;glito = $e5
;tie = $e6
;freefree = $e7

;prgads = $f0 
;prgpor = $f1
;prgwav = $f2
;prgfre = $f3
;prgpul = $f4
;prgfil = $f5
;prghar = $f6

;depack prg
;0000=instrument (5 low-bits) \/ glide type (3 hi-bits)
;0080=note/gate \/ $80 end marker
;0100=prgads value
;0180=prgpor value / glide value
;0200=prgwav value
;0280=prgfre value
;0300=prgpul value
;0380=prgfil value
;0400=prghar value ;3 hi-bits free
;0480=speed value \/ $80 sets marker for pattern cmd used

;pack order:speed,val,dur,instr,prgads,val,prgwav,val,prgfre,val,prgpul,val,prgfil,val,prghar,val,prgpor,val,note

;==========================================================	
editor_queue_clear_depack
	jsr init_io_ram
	ldy #$00
	
clear_depacked_memory
	stx clear_depack_p0+2
	stx clear_depack_p1+2
	inx
	stx clear_depack_p2+2
	stx clear_depack_p3+2
	inx
	stx clear_depack_p4+2
	stx clear_depack_p5+2
	inx
	stx clear_depack_p6+2
	stx clear_depack_p7+2
	inx
	stx clear_depack_p8+2
	stx clear_depack_p9+2	
	
	lda #$00
-	
clear_depack_p0	sta $d000,y
clear_depack_p1	sta $d080,y
clear_depack_p2	sta $d100,y
clear_depack_p3	sta $d180,y
clear_depack_p4	sta $d200,y
clear_depack_p5	sta $d280,y
clear_depack_p6	sta $d300,y
clear_depack_p7	sta $d380,y
clear_depack_p8	sta $d400,y
clear_depack_p9	sta $d480,y
clear_depack_opcode	iny
	bpl -
	rts	
	

	
	
depack_pattern
	lda #$c8
	sta clear_depack_opcode
	tya
	tax
	jsr editor_queue_clear_depack
	
	ldx zp_ed_channel_temp

	lda depacked_screen_pattern_bank,x
	jsr convert_voice_x_to_memory_
	sta zp_ed_scr_to_buffer

	ldy #$00
	sty zp_ed_scr_to_lo
	sty zp_ed_depack_row
	sty zp_ed_depack_dur_buffer
	sty zp_ed_scr_nybble_hi	;glide type
	sty zp_ed_scr_nybble_lo	;instrument
	dey
	sty zp_ed_depack_pattern_pos
	

	ldy depacked_screen_pattern,x
		
	lda patterns_lo,y
	sta zp_ed_scr_from_lo
	lda patterns_hi,y
	sta zp_ed_scr_from_hi

			
depack_pattern_loop
	inc zp_ed_depack_pattern_pos	
	ldy zp_ed_depack_pattern_pos	
	lax (zp_ed_scr_from_lo),y
	
	beq skip_depack_nonote
	bmi depack_dur_or_cmd
	cmp #ins00
	bcs depack_new_instrument

	;NOTE found; last thingy in pattern chunk
	ldx #$80
	jsr depack_result_to_memory

	lda zp_ed_scr_nybble_lo	;mix instrument with glide type
	
skip_depack_nonote		;set instrument to 0
	ldy zp_ed_depack_row
	ldx zp_ed_scr_to_buffer
	stx zp_ed_scr_to_hi
	ldx #0
	stx zp_ed_scr_to_lo
	
	ora zp_ed_scr_nybble_hi
	sta (zp_ed_scr_to_lo),y
	
	stx zp_ed_scr_nybble_hi

	tya
	sec	;dur 0 = 1 so always add 1
	adc zp_ed_depack_dur_buffer
	sta zp_ed_depack_row
	bcc depack_pattern_loop
		
depack_new_instrument
	anc #%00011111
	sta zp_ed_scr_nybble_lo
	bcc depack_pattern_loop	 
	
depack_dur_or_cmd
	cmp #gateoff
	bcs depack_cmd
	
	and #$7f
	sta zp_ed_depack_dur_buffer
	bcc depack_pattern_loop	
	
depack_cmd
	cmp #gliup
	bcs +
	and #$7f
	;gateon or gateoff
	ldx #$80
	jsr depack_result_to_memory
	bcc depack_pattern_loop	
	
+	cmp #speed
	bcs depack_pattern_command
	
depack_pattern_glide_cmd
	asl
	asl
	asl
	asl
	asl
	cmp #%10100000	;tie
	sta zp_ed_scr_nybble_hi			
	
	;no glide value clearing, this could be a glissando table pointer
	;else do lda #0 before fetch_and_depack_result_to_memory to clear the glissando
	bcs depack_pattern_loop

	ldx #$00
	stx zp_ed_scr_to_lo
	ldx zp_ed_scr_to_buffer
	stx zp_ed_scr_to_hi
	
	ldx #$81
	jsr fetch_and_depack_result_to_memory
	bcc depack_pattern_loop
	
depack_pattern_command
	cmp #end
	beq depack_pattern_done

	ldx #$84
	
	cmp #prgads
	bcc depack_pattern_speed
	
depack_pattern_cmd_direct	
	anc #$07
	tay
	ldx depack_pattern_command_page,y
depack_pattern_speed	
	jsr fetch_and_depack_result_to_memory
	
depack_set_pattern_cmd_marker	
	lda zp_ed_scr_to_buffer
	;clc
	adc #$04
	jsr depack_pattern_set_marker	;include pattern cmd marker
	jmp depack_pattern_loop


	
depack_pattern_done
	lda zp_ed_scr_to_buffer
	jsr depack_pattern_set_marker	;include end marker
	
 	;set pattern length somewhere in memory
	ldx zp_ed_channel_temp	
	tya
	sta depacked_screen_pattern_length,x
	
	jmp return_io	

	
depack_pattern_set_marker	
	sta zp_ed_scr_to_hi
	lda #$80	
	sta zp_ed_scr_to_lo
	ldy zp_ed_depack_row
	lda (zp_ed_scr_to_lo),y
	ora #$80		
-	sta (zp_ed_scr_to_lo),y
	rts		
	
		
;==========================================================
;depack_result_to_memory

;in: X = slot page (0-4) \/ slot hi nybble ($00 or $80)
;in: A = byte
;in: C = 
fetch_and_depack_result_to_memory
;	bcs depack_result_to_memory
	inc zp_ed_depack_pattern_pos
	ldy zp_ed_depack_pattern_pos
	lda (zp_ed_scr_from_lo),y
	
depack_result_to_memory
	tay
	txa
	and #$80
	sta zp_ed_scr_to_lo
	txa
	anc #$07
	adc zp_ed_scr_to_buffer
	sta zp_ed_scr_to_hi
	tya
	ldy zp_ed_depack_row
	sta (zp_ed_scr_to_lo),y
	rts	

		

;==========================================================
;
;0000=instrument \/ glide type
;0080=note/gate \/ $80 end marker
;0100=prgads value
;0180=prgpor value / glide value
;0200=prgwav value
;0280=prgfre value
;0300=prgpul value
;0380=prgfil value
;0400=prghar value ;hi 3bits free
;0480=speed value \/ $80 sets marker for pattern cmd used


;in x = 0 (nonIRQ) or 2 (IRQ)
;in y = channel (0,7,14)


screen_pattern_data
	jsr init_io_ram

	lda start_end_scroll_column,y
	sta zp_ed_scr_column,x

	lda screen_pattern_bank,y
	cpx #0
	bne +
	lda depacked_screen_pattern_bank,y
+	clc
	adc screen_pattern_data_column,y
	sta zp_ed_scr_temp,x
	sta zp_ed_scr_from_hi,x

	ldy zp_ed_scr_to_row,x	;add row screen lo with column
	
screen_pattern_data_loop	
	jsr screen_pattern_data_set_row
	
	
;-------------------------	
poke_screen_pattern_data	

	lda zp_ed_scr_from_lo,x
	and #$7f
	sta zp_ed_scr_from_lo,x

			
	ldy zp_ed_scr_column,x
	bne screen_2nd_3rd_columns

	jsr convert_byte_to_decimal_text_scr_inverse
	
	tya
;	ora #$80
	;---
	sta (zp_ed_scr_to_lo,x)
	inc zp_ed_scr_to_lo,x	;never 0, zp_ed_scr_to_hi doesnt need adjustment

		
	lda zp_ed_scr_nybble_lo,x
	ora #$80
	bne screen_first_column
		
screen_2nd_3rd_columns
	ldy #" "+$80
	and #3
	bne +
	ldy #"-"+$80
+	tya
screen_first_column	
	;---
	sta (zp_ed_scr_to_lo,x)
	inc zp_ed_scr_to_lo,x	;never 0, zp_ed_scr_to_hi doesnt need adjustment

			
	;poke instrument data
	lda #0
	sta zp_ed_scr_nybble_lo,x
	ldy #$20
	
	lda (zp_ed_scr_from_lo,x)
	pha	;store glide bits
	anc #$1f
	beq +

	jsr convert_byte_to_text_scr

+
	tya
	sta (zp_ed_scr_to_lo,x)
	inc zp_ed_scr_to_lo,x	;never 0, zp_ed_scr_to_hi doesnt need adjustment

				
	lda zp_ed_scr_nybble_lo,x
	sta (zp_ed_scr_to_lo,x)
	inc zp_ed_scr_to_lo,x	;never 0, zp_ed_scr_to_hi doesnt need adjustment

	
	;set note page for depacked memory
	lda zp_ed_scr_from_lo,x
	ora #$80
	sta zp_ed_scr_from_lo,x

	;init / get NOTE
	lda #$00
	sta zp_ed_scr_nybble_hi,x
	
	ldy #$20
	
	lda (zp_ed_scr_from_lo,x)
	and #$7f	;remove possible end marker
	beq note_is_empty

	ldy #"-"
	
	cmp #(gateoff&$7f)
	beq note_is_gateoff
	
	bcc convert_note_found

	ldy #"+"
note_is_gateoff
	sty zp_ed_scr_nybble_hi,x
note_is_empty
	sty zp_ed_scr_nybble_lo,x
	tya
	bpl poke_note_found		
	
convert_note_found
;	clc	;c=0, first substraction needs to be 13 (note c-1 = 13)
	ldy #$2f	
-	sbc #12
	iny
	bcs -
	sty zp_ed_scr_nybble_lo,x
	;A negative
	;adc #12
	tay		
	lda editor_sharps+1-244,y
	sta zp_ed_scr_nybble_hi,x
	
	lda editor_notes+1-244,y

poke_note_found
	sta (zp_ed_scr_to_lo,x)
	inc zp_ed_scr_to_lo,x	;never 0, zp_ed_scr_to_hi doesnt need adjustment

			
	lda zp_ed_scr_nybble_hi,x
	sta (zp_ed_scr_to_lo,x)
	inc zp_ed_scr_to_lo,x
	bne +
	inc zp_ed_scr_to_hi,x
+

	lda zp_ed_scr_nybble_lo,x
	sta (zp_ed_scr_to_lo,x)
	inc zp_ed_scr_to_lo,x
	bne +
	inc zp_ed_scr_to_hi,x
+

	;GET pattern cmd MARKER
	;from_lo = $80
	lda zp_ed_scr_from_hi,x
	clc
	adc #$04
	sta zp_ed_scr_from_hi,x
	
	lda (zp_ed_scr_from_lo,x)
	and #$80
	sta zp_ed_scr_nybble_prehi,x

	ldy #" "
	sty zp_ed_scr_nybble_lo,x

	pla		;from instrument data location
	and #%11100000
	
;gliup = $e2	;%01000000
;glido = $e3	;%01100000
;glito = $e4	;%10000000
;tie = $e5	;%10100000
;prgpor = $f1	;%00100000
	
	cmp #%10000000
	beq set_glide_values_G
	
	cmp #%01100000
	beq set_glide_values_D

	cmp #%01000000
	beq set_glide_values_U

	cmp #%10100000
	bne poke_glide_values
	
	lda #$1f	;<-
	ora zp_ed_scr_nybble_prehi,x
	bne poke_glide_values+2
	
set_glide_values_G		
	lda #"G"
	.byte $0c
set_glide_values_D	
	lda #"D"
	.byte $0c
set_glide_values_U	
	lda #"U"
	ora zp_ed_scr_nybble_prehi,x
	sta zp_ed_scr_nybble_prehi,x

	lda zp_ed_scr_from_hi,x
	;sec
	sbc #$03	
	sta zp_ed_scr_from_hi,x
	clc
	lda (zp_ed_scr_from_lo,x)
	jsr convert_byte_to_text_scr

poke_glide_values		
	lda zp_ed_scr_nybble_prehi,x
	sta (zp_ed_scr_to_lo,x)
	inc zp_ed_scr_to_lo,x
	bne +
	inc zp_ed_scr_to_hi,x
+

	tya
	sta (zp_ed_scr_to_lo,x)
	inc zp_ed_scr_to_lo,x	;never 0, zp_ed_scr_to_hi doesnt need adjustment

		
	lda zp_ed_scr_nybble_lo,x
	sta (zp_ed_scr_to_lo,x)

;===	

	lda zp_ed_scr_temp,x			
	sta zp_ed_scr_from_hi,x	

	lda (zp_ed_scr_from_lo,x)
	bmi clear_screen_pattern_data_loop
	
		
	ldy zp_ed_scr_to_row,x
	iny	
	tya
	cmp zp_ed_scr_to_row_end,x
	bcs screen_pattern_data_exit
	
	sty zp_ed_scr_to_row,x
	inc zp_ed_scr_from_lo,x	
	jmp screen_pattern_data_loop	
	
	
clear_screen_pattern_data_loop
	lda zp_ed_scr_to_row,x
	cmp zp_ed_scr_to_row_end,x
	beq clear_screen_pattern_data
	bcs screen_pattern_data_exit
	
clear_screen_pattern_data
	tay
	jsr screen_pattern_data_set_row
		
	
	ldy zp_ed_scr_column,x
	lda start_end_scroll_column+7,y 
	sta zp_ed_scr_nybble_prehi,x
	
-	
	lda pattern_columns_empty,y
	ora #$20
	sta (zp_ed_scr_to_lo,x)
	inc zp_ed_scr_to_lo,x
	bne +
	inc zp_ed_scr_to_hi,x
+	iny
	tya
	cmp zp_ed_scr_nybble_prehi,x
	bcc -
	inc zp_ed_scr_to_row,x	
	bcs clear_screen_pattern_data_loop
	
screen_pattern_data_exit

	
	jmp return_io

	
screen_pattern_data_set_row
	lda screen_row_lo,y
	clc
	adc zp_ed_scr_column,x
	sta zp_ed_scr_to_lo,x
	
	lda screen_row_hi,y
	adc zp_ed_scr_to_buffer,x
	sta zp_ed_scr_to_hi,x
	rts

		
;screen_pattern_data_poke_memory
;don't use subroutine, it needs to be as fast as possible
	;---
	;sta (zp_ed_scr_to_lo,x)
	;inc zp_ed_scr_to_lo,x
	;bne +
	;inc zp_ed_scr_to_hi,x
+	;---	
	;rts	