
	
;==========================================================
;follow_play_from_start
;
;F1 function key
;IRQ (hi-prio function)

follow_play_current_patterns
	lda current_screen_pattern
	sta free_play_v1_patterns+0
	lda current_screen_pattern+7
	sta free_play_v2_patterns+0
	lda current_screen_pattern+14
	sta free_play_v3_patterns+0	
		
	lda #3
	.byte $0c
follow_play_from_current
	lda #2
	.byte $0c
follow_play_from_start
	lda #1
	sta zp_ed_follow_play_mode

	
;dont play song while packing (i.e. after paste or insert function) it will crash the player if the patterns aren't fully packed
	lda pack_current_screen_pattern
	ora pack_current_screen_pattern+7
	ora pack_current_screen_pattern+14
	beq +
	lda #0
	sta zp_ed_follow_play_mode
	jmp reset_screen_editor_master
	
+	
	
	jsr reset_editor_queue
	
	
	jsr close_edit_window

	lda #0
	sta zp_ed_clock_timer_minutes
	sta zp_ed_clock_timer_seconds
	sta zp_ed_clock_timer_frames	
	
	jsr init_edit_modes_follow_play
	
	jsr init_pattern_data	;set rendered flag to $80

	
	ldy zp_ed_follow_play_mode
	cpy #3
	bne +
	
	ldx #17
	lda #$0f
	jsr editor_init_song_
	jmp ++
+
	lda current_editing_song
	jsr editor_init_song
+

	jsr tab_through_editor_save_params
		
follow_play_ch1	lda #0
follow_play_ch2	ldx #0
follow_play_ch3	ldy #0
	sta v1_channel_and
	stx v2_channel_and
	sty v3_channel_and

	
	lda zp_ed_follow_play_mode
	cmp #2
	bne follow_play_set_first_step

	ldx #$0e
-	lda current_start_song_pos,x
	sta v1_song_pos,x
	txa
	sbx #$07
	bpl -
		
follow_play_set_first_step


	;makes sure the sequencer starts on a valid pattern, at least not something the editor assumes, but what the player says
	jsr play_song

	
	ldx #$0e
-	lda v1_song_pos,x
	sta current_editing_song_pos,x
	
	;fix for patterns that are allready finished in player after one tick. the player goes to next step, but current pattern is still playing
	lda v1_pattern_pos,x
	bne +
	dec current_editing_song_pos,x
	
+
	txa
	sbx #$07
	bpl -
	
	
follow_play_wait_for_init	
	ldx #<follow_play_wait_for_init
	ldy #>follow_play_wait_for_init

		
	lda screen_pattern_rendered
	ora screen_pattern_rendered+7
	ora screen_pattern_rendered+14
	bmi follow_play_wait_for_init_
	
;start music loop, first valid patterns are finished rendering	
;set repeat value so depacker waits with depacking of next step
	ldx #$0e
-
	sec
	jsr reset_editor_song_pos
	
	lda v1_dur_buffer,x
	adc #0
	cmp screen_pattern_length,x
	bcc +
	dec current_editing_song_pos,x		
+
	txa
	sbx #$07
	bpl -
	
		
	ldx #<follow_play_loop
	ldy #>follow_play_loop
	
follow_play_wait_for_init_
	txa	
	jmp set_current_editing_routine
;--------------------	
follow_play_loop
	
	jsr editor_play_song

	
	ldx #%00111111
	lda v123_multi_speed
	beq +
	ldx #0 
+	stx ed_sprites_flag
	
	jmp jump_move_pattern_up
		
;==========================================================
key_has_no_function

;==========================================================
;escape_all
;
;is called when pressing <-. Does NOT reset values, but returns to last editing state.
;IRQ (hi prio function)

escape_all
	jsr reset_editor_queue
	
	
	ldy #0
	sty $dd0e

	jsr get_song_edit_or_free_play_mode
	ora zp_ed_follow_play_mode
	beq reset_editing_parameters

		
	ldx #$0e	
-	lda #$80
	sta screen_pattern_rendered,x
	sty pack_current_screen_pattern,x
	txa
	sbx #$07
	bpl -
			
	ldx tab_editing_index
	jsr tab_through_editor_return_params

;	lda current_editing_song
	jsr get_song_speed_settings_
	and #$30
	ldy #$3c	;#$0f asl 2x
	sta song_pattern_settings+3,y
		
	lda #$0f
	jsr editor_init_song

		
	
reset_editing_parameters	

	jsr close_edit_window

	jsr init_edit_modes
	
reset_screen_editor_master	
	lda #<screen_editor_master
	ldy #>screen_editor_master
	jmp set_current_editing_routine
	
			

;==========================================================
;instrument up
;IRQ (lo prio function)
; x= $0c	$f3 = ' (;)	= Instrument up / song up
; x= $0d	$f2 = ; (:)	= Instrument down / song down	
instrument_up
instrument_down
	cpx #$0d
	ldy current_editing_song	
	lda zp_ed_song_edit_mode
	beq update_instrument
	
	bcs +
	iny
	cpy #$0f
	bcc set_new_editing_song
+
	dey
	bmi set_instrument_exit
set_new_editing_song
	sty current_editing_song
	sty last_editing_song
	tya
	jmp init_new_song

	
update_instrument	
	php
	jsr get_current_free_play_mode
	bcs update_instrument_free_play_layered_value
	ldx zp_ed_instrument_current
	plp
	bcs decrease_instrument
		
increase_instrument
	inx	
	cpx #$20
	bcc set_instrument_new_value
	ldx #$02
	
decrease_instrument	
	dex
	bne +
	ldx #$1f
set_instrument_new_value	
+	stx zp_ed_instrument_current
set_instrument_exit
	rts
	
	
update_instrument_free_play_layered_value
	ldy free_play_instruments,x
	plp
	bcc increase_instrument_free_play_value
		
decrease_instrument_free_play_value
	dey
	.byte $80
increase_instrument_free_play_value
	iny
	tya
	anc #$1f
	sta free_play_instruments,x
	pha
	bcc update_free_play_layered_preset
	
	
get_current_free_play_mode
	ldx free_play_current_channel	
	ldy zp_ed_free_play_mode
	cpy #9
	ldy zp_ed_octave	
	rts
	
;==========================================================
;cycle_through_multispeed
;IRQ (lo prio function)	

cycle_through_multispeed
	lda #$0f
	ldx zp_ed_free_play_mode
	bne +
	lda current_editing_song
+	jsr get_song_speed_settings_
	clc
	adc #$10
	and #$3f
	sta song_pattern_settings+3,y
	
	cpx #9
	bne +
	sta free_play_current_multispeed
	pha
	ldx #6
update_free_play_layered_preset
	;in x: offset (channel + type(instr(0),octave(3)) or multispeed(6) )
	stx zp_ed_scr_temp+2	
	lda free_play_current_preset
	asl
	asl
	asl
	adc zp_ed_scr_temp+2
	tax
	pla
	sta free_play_layered_presets,x			
	jmp init_free_play_loop_instrument

+
	sta song_pattern_settings_free_play+3
	
	jsr init_free_play_patterns	
	
	lda #$0f
	jmp editor_init_song__
	

;==========================================================
;base note up/down
;IRQ (lo prio function)
;x=$16 = up
;x=$17 = down
base_note_up
base_note_down
	cpx #$17
	ldx zp_ed_note_base
	ldy free_play_arpeggio_type
	lda zp_ed_free_play_mode	
	bne free_play_arpeggio_type_update
	bcs base_note_down_
base_note_up_	
	inx
	cpx #13	
	bcc +
base_note_down_
	dex
	beq ++
+	stx zp_ed_note_base
+	rts	


free_play_arpeggio_type_update
	bcs free_play_arpeggio_type_down
free_play_arpeggio_type_up
	iny
	cpy #(free_play_arpeggios_end-free_play_arpeggios)
	bcc +	
free_play_arpeggio_type_down
	dey
	bpl +
	ldy #0		
+	sty free_play_arpeggio_type
	ldx #2
-	lda free_play_arpeggios,y
	sta free_play_arpeggiator_pointer,x
	lda #0
	sta free_play_arpeggiator_speed,x
	dex
	bpl -
	rts	
;==========================================================
;octave up/down
;IRQ (lo prio function)
;	x= $0e  $f1 = [ (@)	= Octave down / speed down
;	x= $0f $f0 = ] (*)	= Octave up / speed up
octave_up
octave_down
	cpx #$0f
	lda zp_ed_song_edit_mode
	bcc octave_down_
octave_up_
	beq octave_up_editor_only
	.byte $0c
octave_down_
	beq octave_down_editor_only
set_song_speed	
	php
	jsr get_song_speed_settings
	tax
	and #$0f	
	plp
	bcc set_song_speed_down
	inx
	cmp #$0f
	bcc +
set_song_speed_down
	dex
	cmp #$02
	bcc ++
+	txa
	sta song_pattern_settings+3,y
+	rts


octave_down_editor_only
	lda #$fe
	.byte $0c
octave_up_editor_only
	lda #$00	
	jsr get_current_free_play_mode
	bcs set_octave_free_play_layered_mode
	asl
	bne +

	iny
	cpy #8
	bcc ++
+	dey
	bmi screen_editor_master_exit
+	
	sty zp_ed_octave
	sty free_play_current_octave
	sty free_play_current_octave+1
	sty free_play_current_octave+2
screen_editor_master_exit	
	rts	
	
set_octave_free_play_layered_mode	
	adc free_play_current_octave,x
	cmp #8
	bcs screen_editor_master_exit

	sta free_play_current_octave,x
	pha
	txa
	sbx #$fd
	jmp update_free_play_layered_preset
	
	

	

		

	
;==========================================================
;screen_editor_master
;
;controls editing mode (sequencer, pattern, instrument, table data). Is not used in disc menu.
;after every hi-prio user function, this master is (re)set as new function
;IRQ (hi prio function)			
screen_editor_master
	
check_screen_editing_routine
	lda zp_ed_keyboard_speed
	bmi screen_editing_routine	;this is set when a multiframe routine is used, so same JSR
	bne idle_keyboard_function

	lda zp_ed_keyboard_current
	beq idle_keyboard_function
			
	cmp #$f5
	bcs idle_keyboard_function

	cmp #$e6
	bcs valid_key_all_modes
		
	ldy zp_ed_free_play_mode
	bne screen_editor_master_exit	
	
	cmp #$e0
	bcc check_for_valid_value_key
	
	ldy zp_ed_song_edit_mode
	bne screen_editor_master_exit

valid_key_all_modes
	eor #$ff
	tax
	lda keyboard_functions_lo,x	
	sta screen_editing_routine_jump+1
	lda keyboard_functions_hi,x	
	sta screen_editing_routine_jump+2
		
	
screen_editing_routine
	;x=$0c-$1f
screen_editing_routine_jump	
	jmp idle_keyboard_function

;==============================================
idle_keyboard_function_gate_off

idle_keyboard_function
	

	jsr get_song_edit_or_free_play_mode
	bne +
	
	jsr editor_play_song

	lda zp_ed_keyboard_current
	bne +
	
	lda #$fe
	sta v1_channel_and
	sta v2_channel_and
	sta v3_channel_and
+
	clc	;only update, do not make backup of screen behind popup
	jmp open_edit_window

;==============================================
;edit_song_data

edit_song_data
	lda #1		;song name
	sta zp_ed_song_edit_mode
	jsr close_edit_window

	
	jsr tab_through_editor_save_params
	
	jsr editor_init_song
		
	lda #0
	sta ed_sprites_flag
	sta zp_ed_free_play_mode
	sta zp_ed_follow_play_mode
	lda #<check_screen_editing_routine
	ldy #>check_screen_editing_routine
	jmp set_current_editing_routine	
	
	
	
get_song_name_index	
	lda current_editing_song
	asl
	asl
	asl
	asl
	adc zp_ed_song_edit_mode
	tax
set_key_value_instrument_table_exit
	rts

	
;==============================================
;check_for_valid_value_key
;editor mode	
;in: A = key
			
check_for_valid_value_key
	;sta $cffe
	bit zp_ed_keyboard_commodore
	bpl check_for_valid_value_key_pressed
	jmp check_for_valid_value_key_commodore	

check_for_valid_value_key_pressed
	ldx zp_ed_song_edit_mode
	beq check_for_valid_value_key_main
	
	tay
	jsr get_song_name_index
	tya
	sta song_names-1,x	
	jmp move_cursor_right

	
	
;---------------------------------------------------
check_for_valid_value_key_main

	bit current_editing
	bmi check_valid_key_instrument_table_data
	jmp check_valid_key_seq_pattern_data

check_valid_key_instrument_table_data
	bvc +
	jmp check_valid_key_instrument_data
+
	ldy current_instr_table_prg_locked
	beq set_key_value_instrument_table_exit
	
	pha
	ldy current_instr_table_column
	
	jsr instrument_data_get_program_pos
	bcc +
	lax convert_cursor_column_to_nybble+12,y
	bcs ++		
+
	lax convert_cursor_column_to_nybble,y
+	lsr
	bcc set_key_cmd_instrument_table
	
set_key_value_instrument_table
	pla
	jsr check_and_convert_hex_nybble-2
	bcs set_key_value_instrument_table_exit
	
	cpx #$80
	
	ldx zp_ed_instrument_prg_current
	jsr get_instrument_values_vectors

	ldy current_instr_table_prg_pos,x
	lda (zp_ed_scr_from_lo+2),y
		
	jsr nybble_instr_table_cmd_or_value
		
	sta (zp_ed_scr_from_lo+2),y
	jmp move_cursor_right	
		
;==========================	
set_key_cmd_instrument_table

	txa
	anc #$08
	adc zp_ed_instrument_prg_current

	tay
	lda instrument_commands_hi_branches,y
	sta set_instr_table_cmd_branche+1

	pla
	and #$3f
	cmp #" "
	bne +
	lda #"0"	;replace SPACE with 0 value	
+	
set_instr_table_cmd_branche
	bne set_instr_table_cmd

	
set_instr_table_cmd_zero_byte
	cmp #"0"
	bne set_instr_table_cmd+1
	ldy #$ff
	bne set_instrument_table_cmd_valid
	
set_instr_table_cmd_zero_nybble
	cmp #"0"
	bne set_instr_table_cmd+1
	lda #0
	pha
	beq set_instrument_table_nybble_valid
	
set_instr_table_cmd_hex_byte
	jsr check_and_convert_hex_nybble-2
	bcs set_instr_table_cmd_nybble_exit
	pha
	bcc set_instrument_table_nybble_valid

set_instr_table_cmd_hex_nybble
	jsr check_and_convert_hex_nybble-2
	bcs set_instr_table_cmd_nybble_exit 	;no valid hex value, so check for cmd key


	
	;check for hr bit in convert_cursor_column_to_nybble
	txa
	cpx #$80
	
	ldx zp_ed_instrument_prg_current

	and #2
	beq +
	inx	
+
	jsr get_instrument_commands_vectors

	ldx zp_ed_instrument_prg_current
	
	ldy current_instr_table_prg_pos,x
	lda (zp_ed_scr_to_lo+2),y
		
	jsr nybble_instr_table_cmd_or_value

	jmp set_user_data_move_cursor	
	
nybble_instr_table_cmd_or_value	
	
	;carry still from cpx #$80	
	bcc +
	and #$0f
	.byte $0c
+	and #$f0
	ora zp_ed_scr_temp+2
	rts	
	
;================			
set_instr_table_cmd
	clc
	adc #$40
	ldy #0	
	ldx zp_ed_instrument_prg_current

-	cmp instrument_commands_alias_hi,x
	beq set_instrument_table_cmd_valid
	pha
	txa
	sbx #$f8
	pla
	iny
	cpy #((instrument_commands_alias_lo-instrument_commands_alias_hi)/8)+1 
	bcc -
set_key_value_instrument_data_exit	
set_instrument_table_cmd_exit	
set_instr_table_cmd_nybble_exit	
	rts
	
set_instrument_table_cmd_valid
;Y = current cmd
	tya
	eor #$ff
	pha
	
	jsr move_cursor_right	
	
set_instrument_table_nybble_valid
	;pha
	ldx zp_ed_instrument_prg_current
	jsr get_instrument_commands_vectors
	
	ldy current_instr_table_prg_pos,x
	pla
	jmp set_user_data_move_cursor	

;=========================
check_valid_key_instrument_data
	ldy current_instrument_row
	bne set_key_value_instrument_data
	
	ldx current_instrument_column
	dex
	dex
	dex
	dex
	jsr set_key_value_instrument_name
	jmp move_cursor_right

		
	


	
set_key_value_instrument_data
	ldy current_instrument_column
	ldx convert_cursor_column_to_nybble_instr,y
	beq set_key_value_instrument_data_exit

	jsr check_and_convert_hex_nybble-2
	
	bcs set_key_value_instrument_data_exit
	
	lda #>instruments
	sta zp_ed_scr_to_hi+2

	lda zp_ed_instrument_current
	asl
	asl
	asl
	sta zp_ed_scr_to_lo+2
			
	dex
	txa
	and #$07
	tay
	
	lda (zp_ed_scr_to_lo+2),y
	cpx #$80
	jsr nybble_instr_table_cmd_or_value

	cmp instrument_tables_max_length,y
	beq +
	bcs set_key_value_instrument_data_exit
+	jmp set_user_data_move_cursor	

	
	
	
;===check_valid_key_seq_pattern_data===		
check_valid_key_seq_pattern_data
	bvs check_valid_key_pattern_data
	jmp check_valid_key_sequencer_data


		
;===value key pattern data===		
check_valid_key_pattern_data	
	pha
	jsr init_io_ram
	
	jsr set_pattern_memory_location
	;x=column type (hi nybble) /\ channel (lo nybble)
	;y=channel zp_ed_channel_temp+2
	;a=row = zp_ed_scr_from_row+2	

	
	tay	
	lda #0
	sta zp_ed_scr_from_lo+2
	
	;check column	
	txa	
	and #$70
	bne check_valid_key_pattern_note_cmd
	
	;instrument column
	lda #$ef
	sta zp_ed_scr_to_buffer+2
	lda #$1f
check_valid_key_set_nybbles	
	sta zp_ed_scr_nybble_prehi+2	;max value
	
	pla
	jsr check_and_convert_hex_nybble-2
	bcs check_valid_key_pattern_exit
	
max_value_pattern	
	cmp zp_ed_scr_nybble_prehi+2	;check max hi	
	beq +
	bcs check_valid_key_pattern_exit
+

	cpx #$80
	ldy zp_ed_scr_from_row+2
	lda (zp_ed_scr_from_lo+2),y
	bcc +	
	and zp_ed_scr_to_buffer+2 
	.byte $0c
+	and #$f0
	ora zp_ed_scr_temp+2
	jmp check_valid_key_set_value		
			
check_valid_key_pattern_note_cmd

	cmp #$20
	bcs check_valid_key_pattern_cmd
	
check_valid_key_pattern_note	
	lda #$80
	sta zp_ed_scr_from_lo+2
	
	pla
	anc #$3f	
	tay
	
	lda zp_ed_instrument_current 
	sta zp_ed_scr_to_buffer+2
	
	
	lda keyboard_notes,y
	beq check_valid_key_pattern_exit
	bmi +
	
	ldy zp_ed_octave
	jsr calculate_play_note
	
+
	ldy zp_ed_scr_from_row+2	
	and #$7f

	sta (zp_ed_scr_from_lo+2),y
	sta zp_ed_scr_nybble_prehi+2
	beq check_valid_key_clear_note_value
	
	lda zp_ed_channel_temp+2
	;jsr convert_column_to_voice_x
	jsr play_last_set_note
	
	ldy zp_ed_scr_from_row+2
	lda #0	
	.byte $0c
check_valid_key_clear_note_value
	sta zp_ed_scr_to_buffer+2
	sta zp_ed_scr_from_lo+2
	
	jsr get_glide_type_bits
	
	ora zp_ed_scr_to_buffer+2
	
check_valid_key_set_value	
	sta (zp_ed_scr_from_lo+2),y
	
	jmp check_valid_key_pattern_cmd_check_window	
	
	
	pla
check_valid_key_pattern_exit
	jmp return_io
	

	
check_valid_key_pattern_cmd
	cmp #$40
	bcs check_valid_key_pattern_cmd_value
	
	pla
	ldx #%11111111
	cmp #$60	;shift space
	beq +
	ldx #%10000000
	cmp #" "
	beq +
	ldx #%00100000
	cmp #"U"-$40
	beq +
	ldx #%00110000
	cmp #"D"-$40
	beq +
	ldx #%01000000
	cmp #"G"-$40
	beq +
	ldx #%11010000		
	cmp #"T"-$40
	bne check_valid_key_pattern_exit
+	txa
	asl
	sta zp_ed_scr_temp+2
	bcc clear_glissando_value	;D,U,G keys
	
			;tie/space key
			;need to clear D,U,G command values, but not glissando values
	cmp #%11111110		;#clearall
	beq clear_all_pattern_commands

			
	jsr get_glide_type_bits
	beq fetch_instrument_mix_glissando_value
	
clear_glissando_value		
	inc zp_ed_scr_from_hi+2
	lda #$80
	sta zp_ed_scr_from_lo+2
	asl		
	sta (zp_ed_scr_from_lo+2),y
	dec zp_ed_scr_from_hi+2
	sta zp_ed_scr_from_lo+2
	
	
fetch_instrument_mix_glissando_value		
	lda (zp_ed_scr_from_lo+2),y	;fetch instrument value
	anc #%00011111
	ora zp_ed_scr_temp+2
	bcc check_valid_key_set_value

	
check_valid_key_pattern_cmd_value
	lda zp_ed_window_open_row
	bne check_valid_key_pattern_cmd_popup_value	

	
	jsr get_glide_type_bits
	beq check_valid_key_pattern_exit-1
	
	lda #$0f
	sta zp_ed_scr_to_buffer+2
	lda #$80
	sta zp_ed_scr_from_lo+2
	lda #$5f		;max glide value
	inc zp_ed_scr_from_hi+2
	bne +
	
check_valid_key_pattern_cmd_popup_value
	stx zp_ed_channel_temp+2
	eor #$0f
	sbc #5
	tax
	jsr set_pattern_cmd_memory_location

	bcs check_valid_key_pattern_exit-1
	ldx zp_ed_channel_temp+2	
+
	jmp check_valid_key_set_nybbles
	

	
clear_all_pattern_commands
	ldx #$0c	;noop $0000
	stx clear_depack_p0
	stx clear_depack_p1
	
	jsr get_glide_type_bits
	beq +
	stx clear_depack_p3	
+	
	ldx zp_ed_scr_from_hi+2

	jsr clear_current_line_depacked_memory+2

		;return original instruction
	lda #$99  	;sta $0000,y
	sta clear_depack_p0
	sta clear_depack_p1
	sta clear_depack_p3
	
		
check_valid_key_pattern_cmd_check_window
	lda #$10	
	ldy zp_ed_window_open_row
	beq update_pattern_screen_from_buffer
	
	
	
check_valid_key_set_cmd_marker	
	ldx #0
	stx zp_ed_scr_temp+2
-
	stx zp_ed_scr_to_buffer+2

	jsr set_pattern_memory_location
	tay
	
	ldx zp_ed_scr_to_buffer+2	
	jsr set_pattern_cmd_memory_location
	bcs +
	
	lda (zp_ed_scr_from_lo+2),y
	and instrument_tables_max_length,x
	ora zp_ed_scr_temp+2 
	sta zp_ed_scr_temp+2	
+	
	inx
	cpx #8
	bcc -	

	
	lda (zp_ed_scr_from_lo+2),y
	and #$7f
	ldx zp_ed_scr_temp+2
	beq +
	ora #$80	
+	sta (zp_ed_scr_from_lo+2),y
	
	ldx #$13
	bne move_cursor_after_update_pattern
	

	
	
					
update_pattern_screen_from_buffer
	pha
	
	jsr update_pattern_screen_row_fetch

	lda #12
	ldx #0	
	jsr update_pattern_screen_to_buffer
	
	jsr update_pattern_screen_row_fetch
	cmp #25
	bcs +
	;update temp screen top
	jsr copy_screen_line_to_temp_screen
+
	jsr update_pattern_screen_row_fetch
	sec
	sbc screen_pattern_length,y
	bmi +
	;update temp screen bottom
	jsr copy_screen_line_to_temp_screen
+
	pla
	tax
	beq +

move_cursor_after_update_pattern
	jsr move_cursor
	
+
	jsr convert_column_to_voice_x
	;zp_ed_channel_temp+2 is set to $0e,$07,$00 in move_cursor loop

	lda #1
	sta pack_current_screen_pattern,x
	jmp return_io
	
update_pattern_screen_to_buffer		
	
	sta zp_ed_scr_to_row+2
	sta zp_ed_scr_to_row_end+2
	stx zp_ed_scr_to_buffer+2
	ldx #2
	jmp screen_pattern_data	

update_pattern_screen_row_fetch	
	ldy zp_ed_channel_temp+2
	lda zp_ed_scr_from_row+2
	sta zp_ed_scr_from_lo+2	;index
	clc
	adc #12
	rts
	
set_pattern_memory_location
	ldy current_screen_column
	lax convert_cursor_column_to_nybble,y
	
	;set channel base location
	anc #$0f
	tay	;channel
	sty zp_ed_channel_temp+2
	lda screen_pattern_data_column,y
	adc screen_pattern_bank,y
	sta zp_ed_scr_from_hi+2
	
	lda pattern_memory_position,y
	sta zp_ed_scr_from_row+2
	rts	

get_glide_type_bits	
	lda (zp_ed_scr_from_lo+2),y	;fetch glide type bits
	and #%11100000
	beq +
	cmp #%10100000	
+	rts

	 				
;-------------------------
	
	
set_pattern_cmd_memory_location	
	lda depack_pattern_command_page,x
	anc #$07
	adc zp_ed_scr_from_hi+2
	sta zp_ed_scr_from_hi+2
	lda depack_pattern_command_page,x
	and #$80
	sta zp_ed_scr_from_lo+2
	lda #$0f
	cpx #1
	bne +
	bit zp_ed_glide_command
	beq ++
	sec
	rts
+
	cpx #7		;command marker
	bne +
	lda #$8f
+	sta zp_ed_scr_to_buffer+2
	lda instrument_tables_max_length,x
	clc
	rts		

		
;--------------------------------------
;===
		
play_last_set_note
	tay	
		
	jsr init_free_play_pattern

	lda start_end_scroll_column,y
	asl
	and #$30
	sta zp_ed_scr_to_lo+2
	lda #>free_play_patterns
	sta zp_ed_scr_to_hi+2

	ldy #1
	lda zp_ed_instrument_current
	ora #ins00	
	sta (zp_ed_scr_to_lo+2),y
	
	iny
	lda zp_ed_scr_nybble_prehi+2
	sta (zp_ed_scr_to_lo+2),y
	rts

	
init_free_play_pattern

	lda #0
	sta v1_pattern_speed_pos,y
	sta v1_dur_timer,y
	sta v1_pattern_pos,y
	lda #1
	sta v1_pattern_speed_timer,y	
	lda #$ff
	sta v1_channel_and,y
;	sta v1_hard_restart_timer,y
	lda #<free_play_v1_patterns
	sta v1_song_pos,y	
	rts
			
;==================================================
;check_valid_key_sequencer_data
check_valid_key_sequencer_data
	cmp #$20	;space
	beq set_sequencer_data_start_pos
	cmp #$60	;shift space
	bne check_valid_key_sequencer_data_
set_sequencer_data_all_start_pos
	ldy #3
	sty zp_ed_scr_temp+2
-	jsr set_sequencer_data_start_pos+2
	inc zp_ed_scr_temp+2
	ldy zp_ed_scr_temp+2
	cpy #6
	bcc -
	rts
		
set_sequencer_data_start_pos
	ldy current_sequencer_row	
	jsr get_cursor_value_sequencer
	bcs +		
	lda current_sequencer_song_list
	sta current_start_song_pos,x
+	rts

set_sequencer_data_memory_pos
	lda current_sequencer_row
	jsr set_sequencer_data_memory_pos_
	sta zp_ed_scr_to_hi+2
	sta zp_ed_scr_from_hi+2
	
	ldx current_sequencer_column	
	lda current_sequencer_highest_pos
	clc
	adc convert_column_instr_to_table_prg,x
	rts

set_sequencer_data_memory_pos_
		
	clc
	adc #>s0_v1_patterns
	sbc #2
-	
	rts
	
check_valid_key_sequencer_data_	

	pha		;store key value
	
	jsr set_sequencer_data_memory_pos	
	sta zp_ed_scr_to_lo+2	
	beq skip_sequencer_loop_check
	
	
	;check previous step for loop cmd
	jsr check_sequencer_previous_step
	cmp #loop
	bne skip_sequencer_loop_check

	lda current_sequencer_column_nybble
	lsr	;hi/lo column
	pla	;get key	
	jsr check_and_convert_hex_nybble
	bcs -
	
		;get memory value
	jsr sequencer_get_nybble_value
	bcc +
	and #$0f
	.byte $0c
+	and #$f0
	sec
	jmp ora_sequencer_data_value
	

	
skip_sequencer_loop_check	
	jsr sequencer_get_nybble_value
	pla		;get key value
	php		;push current nybble edit (0=lo/1=hi)
	bcc set_sequencer_data_value
			
	and #$3f

	cmp #"U"-$40
	bne set_key_sequencer_check_down
	
	jsr check_valid_sequencer_double_up_down_command
	bcs cancel_sequencer_user_data
	
	ldy #up00		
	bne set_sequencer_data_cmd

	
set_key_sequencer_check_down	
	cmp #"D"-$40
	bne set_key_sequencer_check_repeat
	
	jsr check_valid_sequencer_double_up_down_command
	bcs cancel_sequencer_user_data
	
	ldy #dwn00
	bne set_sequencer_data_cmd

set_key_sequencer_check_repeat 
	cmp #"R"-$40
	bne set_key_sequencer_check_loop
	jsr check_valid_sequencer_double_repeat_command
	bcs cancel_sequencer_user_data
	
	ldy #rpt00
	bne set_sequencer_data_cmd
	
set_key_sequencer_check_loop 
	cmp #"L"-$40
	bne set_key_sequencer_check_stop
		
	;init loop value to 0
	ldy #1
	lda #0	
	sta (zp_ed_scr_to_lo+2),y

	jsr move_cursor_right		
	ldy #loop	
	bne set_sequencer_data_cmd
	
	
set_key_sequencer_check_stop
	cmp #"S"-$40
	bne set_sequencer_data_value
	
	;make sure only a pattern value is set before a STOP command
	jsr check_sequencer_previous_step
	eor #0
	bmi cancel_sequencer_user_data
	
	jsr move_cursor_right
	ldy #stop
	
set_sequencer_data_cmd
	tya
	ldy #0			
	plp
set_user_data_move_cursor
	sta (zp_ed_scr_to_lo+2),y		
	jmp move_cursor_right	
	
cancel_sequencer_user_data	
	plp
	rts
		
set_sequencer_data_value
	plp		;
	jsr check_and_convert_hex_nybble
	;sta zp_ed_scr_temp+2	
	bcs check_valid_key_sequencer_data_exit

	jsr sequencer_get_nybble_value
		
	bcc get_sequencer_data_hi_nybble
	
	cmp #dwn00
	bcc get_sequencer_data_lo_nybble
	lda #0
get_sequencer_data_lo_nybble
	anc #$0f
	bcc ora_sequencer_data_value

		
get_sequencer_data_hi_nybble
	cmp #loop
	beq check_valid_key_sequencer_data_exit
	cmp #stop
	bne +
	lda #0
+	and #$f0
	cmp #up00
	bcs ora_sequencer_data_value 
	cmp #dwn00
	bcc ora_sequencer_data_value
	
	pha
	lda zp_ed_scr_temp+2
	beq +	
	eor #$0f
	sta zp_ed_scr_temp+2
	inc zp_ed_scr_temp+2	
+	pla
	
ora_sequencer_data_value
	ora zp_ed_scr_temp+2
	bcs set_sequencer_data_byte
	
	cmp #max_number_of_patterns
	bcs check_valid_key_sequencer_data_exit

set_sequencer_data_byte
	cmp #loop
	bcc set_user_data_move_cursor	
check_valid_key_sequencer_data_exit	
	rts
	
sequencer_get_nybble_value
	ldy #0
	lda current_sequencer_column_nybble
	lsr
	lda (zp_ed_scr_to_lo+2),y
	rts
	
check_sequencer_next_step	
	inc zp_ed_scr_to_lo+2
	jsr sequencer_get_nybble_value	
	dec zp_ed_scr_to_lo+2
	rts
check_sequencer_previous_step	
	dec zp_ed_scr_to_lo+2
	jsr sequencer_get_nybble_value	
	inc zp_ed_scr_to_lo+2
	rts
	
check_valid_sequencer_double_up_down_command
	jsr check_sequencer_next_step
	cmp #loop
	bcs check_valid_sequencer_double_true
	cmp #rpt00
	bcs check_valid_sequencer_double_false
	cmp #dwn00
	bcs check_valid_sequencer_double_true

	jsr check_sequencer_previous_step
	cmp #rpt00
	bcs check_valid_sequencer_double_false	
	cmp #dwn00
	bcs check_valid_sequencer_double_true

check_valid_sequencer_double_false	
	clc
check_valid_sequencer_double_true	
	rts

check_valid_sequencer_double_repeat_command	
	jsr check_sequencer_next_step
	cmp #rpt00
	bcs check_valid_sequencer_double_true
	
	jsr check_sequencer_previous_step
	cmp #end
	beq check_valid_sequencer_double_false
	cmp #rpt00
	bcs check_valid_sequencer_double_true
	bcc check_valid_sequencer_double_false

;============================================================
;back_space


back_space
	jsr get_song_edit_or_free_play_mode
	beq back_space_main
	
	and zp_ed_song_edit_mode
	bne +
	jmp free_play_glide_up
	
+	
		
	jsr get_song_name_index
	and #$f0
	adc #$10
	sta zp_ed_scr_temp+2
	dex
-	lda song_names,x
	sta song_names-1,x
	inx
	cpx zp_ed_scr_temp+2 
	bcc -
	dex
	jsr set_space_song_name
	jmp move_cursor_left

	
back_space_main
	bit current_editing
	bmi back_space_instrument_data
	bvs back_space_pattern
	
back_space_sequencer

	ldy #1
	sty zp_ed_scr_from_lo+2
	sty zp_ed_scr_temp+2
	dey
	sty zp_ed_scr_to_lo+2
	
	jsr set_sequencer_data_memory_pos
	
	tay
	sta zp_ed_scr_column+2 
-	
	jsr check_loop_insert_back_space_sequencer	
	
	iny
	cpy #$f8
	bne -
	
	dey
	jmp set_sequencer_end_value
	
			
;----------------------------	
	
back_space_pattern
		
	jsr prepare_insert_back_space_pattern
	bit zp_ed_keyboard_speed
	bmi skip_frame_back_space_pattern
	
	
-	tya
	sta back_pat_fr_0+2,x
	sta back_pat_to_0+2,x
	iny
	txa
	sbx #$fa
	cpx #$1e
	bcc -

	ldx zp_ed_channel_temp+2

	ldy screen_pattern_length,x
	sty zp_ed_scr_temp+2
	dey
	sty zp_ed_scr_to_row_end+2
	sty zp_ed_scr_from_row+2

	ldy pattern_memory_position,x
	jsr back_space_pattern_memory
	
	jmp insert_back_space_lock_keyboard	
	
	
skip_frame_back_space_pattern	
	ldx zp_ed_channel_temp+2
	lda zp_ed_scr_to_row_end+2
	eor #$80
	sta zp_ed_scr_from_row+2
	lda pattern_memory_position,x
	eor #$80
	tay
	jsr back_space_pattern_memory
	
	
	;clear last tick in memory	
	ldy zp_ed_scr_to_row_end+2
	jsr clear_current_line_depacked_memory

	
	ldy zp_ed_scr_from_lo+2	;index
	
	jsr scroll_back_pattern_opcodes
	
	jsr init_pattern_scroll_back_insert
		
	jsr scroll_back_pattern_loop
	
	
	ldy zp_ed_channel_temp+2 
			
update_pattern_screen
	lax zp_ed_scr_to_row_end+2	;63
	clc
	sbc zp_ed_scr_from_lo+2	;77
	bcs +
	adc #25
	stx zp_ed_scr_from_lo+2
	.byte $0c
+	lda #24
	ldx #0
	jmp update_pattern_screen_to_buffer

	
		
;=============================	
back_space_instrument_data
	bvc back_space_instrument_tables
	
back_space_instrument_name	
	ldy current_instrument_row
	bne back_space_exit
	
	lax current_instrument_column
	sbx #4
	jsr get_instrument_name_index
	sty get_char_instr_name+2
	sta get_char_instr_name+1
	
-
get_char_instr_name
	lda instrument_names,x
	dex
	jsr set_key_value_instrument_name
	inx
	inx
	cpx #16
	bcc -
	dex
	jsr set_space_value_instrument_name	
	jmp move_cursor_left
	

	



;---------

		
back_space_instrument_tables
	jsr instrument_data_check_skip
	bne +
back_space_exit
	rts
	
+	
	jsr get_instrument_commands_vectors
	
	sta back_instr_tab_cmd_get+2
	iny
	sty back_instr_tab_cmd_get+1
	
	jsr get_instrument_values_vectors
	
	sta back_instr_tab_val_get+2
	sta back_instr_tab_val_get_speed+2
	iny
	sty back_instr_tab_val_get+1
	sty back_instr_tab_val_get_speed+1
		
	ldy current_instr_table_prg_pos,x
	
	sty zp_ed_scr_to_row+2
	
	cpx #7	;check for speedtable
	beq back_instr_tab_val_get_speed

back_instr_tab_cmd_get
	lax adsr_table_cmd+1,y
	sta (zp_ed_scr_to_lo+2),y
back_instr_tab_val_get
	lda adsr_table_value+1,y
	cpx #loop
	bne +
	cmp zp_ed_scr_to_row+2
	beq +
	bcc +
	sbc #1
+
	sta (zp_ed_scr_from_lo+2),y
	iny
	bne back_instr_tab_cmd_get
	
	dey
	
	jsr back_insert_instr_table_init

-	
	ldy instruments,x
	cpy zp_ed_scr_to_row+2
	beq +
	bcc +
	cpy #1
	beq +
	dec instruments,x
+	
	sbx #$08
	bcs -
	bcc back_instr_tab_update_pattern_pointers
	

back_instr_tab_val_get_speed
	lax adsr_table_value+1,y
	bpl ++
	and #$7f
	cmp zp_ed_scr_to_row+2
	beq +
	bcc +
	dex
+	
	txa
+	
	sta (zp_ed_scr_from_lo+2),y
	iny
	cpy #$80
	bcc back_instr_tab_val_get_speed
	
	dey
	lda #0
	sta (zp_ed_scr_from_lo+2),y
	

back_instr_tab_update_pattern_pointers
	dec zp_ed_repack_inserts
	jmp insert_instr_tab_update_pattern_pointers+2	
	
back_insert_instr_table_init	
	lda #0
	sta (zp_ed_scr_to_lo+2),y
	sta (zp_ed_scr_from_lo+2),y

	lax zp_ed_instrument_prg_current
	sbx #$08
	txa
	rts
	
back_space_pattern_memory							
-
back_pat_fr_0	lda $d001,y
back_pat_to_0	sta $d000,y
	lda $d101,y
	sta $d100,y
	lda $d201,y
	sta $d200,y
	lda $d301,y
	sta $d300,y
	lda $d401,y
	sta $d400,y

	iny
back_pat_length	cpy zp_ed_scr_from_row+2
	bcc -
	
	rts
	
clear_current_line_depacked_memory
	ldx zp_ed_scr_to_buffer+2	
	lda #$0c
	sta clear_depack_opcode	
	jmp clear_depacked_memory	
		
;============================================================
;insert_back_space mixed functions

		
check_loop_insert_back_space_sequencer	
	lda (zp_ed_scr_from_lo+2),y
	cmp #loop
	bne +++
	pha	
	iny
	lax (zp_ed_scr_from_lo+2),y
	cmp zp_ed_scr_column+2	
	bcc ++
	lsr zp_ed_scr_temp+2
	bcs +
	inx
	txa	
	sta (zp_ed_scr_to_lo+2),y
	bcc ++
+
	dex
	txa	
	sta (zp_ed_scr_from_lo+2),y 
+	dey
	pla	
+	
	sta (zp_ed_scr_to_lo+2),y
	rts	


	
prepare_insert_back_space_pattern
	jsr init_io_ram
	jsr convert_column_to_voice_x
	
	stx zp_ed_channel_temp+2
	
	lda screen_pattern_position,x
	sta zp_ed_scr_from_lo+2	;index
	
	lda screen_pattern_length,x
	sta depacked_screen_pattern_length,x
	lda #$81	;2 bits:rerender + repack
	sta pack_current_screen_pattern,x
		
	jsr convert_voice_x_to_memory
	sta zp_ed_scr_to_buffer+2
	tay
	ldx #0
	rts

	
		
insert_space_memory	
	
	dey
-	dey

insert_pat_fr_0	lda $d000,y
insert_pat_to_0	sta $d001,y
	lda $d100,y
	sta $d101,y
	lda $d200,y
	sta $d201,y
	lda $d300,y
	sta $d301,y
	lda $d400,y
	sta $d401,y
	cpy zp_ed_scr_from_row+2
	bcs -
	rts	
	
	
init_pattern_scroll_back_insert		
	lda #1
	sta zp_ed_keyboard_speed
init_pattern_scroll_back_insert_	
	ldx zp_ed_channel_temp+2
	ldy start_end_scroll_column+7,x
	sty zp_ed_scr_to_row+2
	ldy start_end_scroll_column+1,x
	rts
	





;=====================================
	
insert_space
	jsr get_song_edit_or_free_play_mode
	beq insert_space_main

	and zp_ed_song_edit_mode
	bne +
	
free_play_glide_down
	ldy free_play_glide_speed	
	bmi free_play_set_glide_exit
	dey
	dey
	.byte $0c
free_play_glide_up
	ldy free_play_glide_speed	
	iny
	cpy #96
	bpl free_play_set_glide_exit
	sty free_play_glide_speed
free_play_set_glide_exit		
	rts


+		
	jsr get_song_name_index
	stx zp_ed_scr_temp+2
	and #$f0
	adc #$0f
	tax
-	lda song_names-1,x
	sta song_names,x
	dex
	cpx zp_ed_scr_temp+2 
	bcs -
set_space_song_name	
	lda #" "
	sta song_names,x
	rts

	
	
skip_frame_insert_space_pattern
	ldx zp_ed_channel_temp+2
		
	lda zp_ed_scr_from_row+2
	eor #$80
	sta zp_ed_scr_from_row+2
	lda screen_pattern_length,x
	sta zp_ed_scr_temp+2
	eor #$80
	tay
	
	jsr insert_space_memory
	
	;clear current line in memory
	ldy pattern_memory_position,x
	jsr clear_current_line_depacked_memory
	
	lda #$0c
	sta clear_depack_opcode
	ldx zp_ed_scr_to_buffer+2
	jsr clear_depacked_memory		
	
	ldy zp_ed_scr_from_lo+2	;index

	jsr scroll_insert_pattern_opcodes
		
	lda #<pattern_columns_empty
	sta zp_ed_scr_from_lo+2
	lda #>pattern_columns_empty
	sta zp_ed_scr_from_hi+2
		
	jsr init_pattern_scroll_back_insert
		
	jsr scroll_insert_pattern_loop
		
	jmp return_io	
	
	
		
	
	

insert_space_main	
	bit current_editing
	bmi insert_space_instrument_data
	bvs insert_space_pattern


insert_space_sequencer
	ldy #1
	sty zp_ed_scr_to_lo+2
	dey
	sty zp_ed_scr_from_lo+2
	sty zp_ed_scr_temp+2
	
	jsr set_sequencer_data_memory_pos
	
	sta zp_ed_scr_column+2
			
	ldy #$f6
-	
	jsr check_loop_insert_back_space_sequencer
	
	cpy #0
	beq +
	dey	
	cpy zp_ed_scr_column+2
	bcs -
	.byte $0c
+	dec zp_ed_scr_to_lo+2
set_sequencer_end_value
	lda #end
	sta (zp_ed_scr_to_lo+2),y
insert_space_exit	
	rts 
	

	
		
;---------------------	
insert_space_pattern
	jsr prepare_insert_back_space_pattern
	bit zp_ed_keyboard_speed
	bmi skip_frame_insert_space_pattern
	
-	tya
	sta insert_pat_to_0+2,x
	sta insert_pat_fr_0+2,x
	iny
	txa
	sbx #$fa
	cpx #$1e
	bcc -

		
	ldx zp_ed_channel_temp+2
	
	ldy pattern_memory_position,x
	iny
	sty zp_ed_scr_from_row+2
	
	ldy screen_pattern_length,x
	
	jsr insert_space_memory

insert_back_space_lock_keyboard	
	lda #$80
	sta zp_ed_keyboard_speed
	jmp return_io

	
	
		
;================================	
insert_space_instrument_data
	bvc insert_space_instrument_tables
	
	ldy current_instrument_row
	bne insert_space_exit
	
	lax current_instrument_column
	sbx #4
	stx zp_ed_scr_temp+2
	jsr get_instrument_name_index
	sty get_char_instr_name_+2
	sta get_char_instr_name_+1
	ldx #14	
-
get_char_instr_name_
	lda instrument_names,x
	inx

	jsr set_key_value_instrument_name
	dex
	dex
	cpx zp_ed_scr_temp+2
	bcs -
	inx
	
set_space_value_instrument_name	
	lda #" "
set_key_value_instrument_name
	pha
	jsr get_instrument_name_index		
	sty set_char_instr_name+2
	sta set_char_instr_name+1
	pla
set_char_instr_name
	sta instrument_names,x
	rts
			
	
			
insert_space_instrument_tables
	jsr instrument_data_check_skip
	beq insert_space_exit
	
	sta zp_ed_scr_to_row+2
	
	jsr get_instrument_commands_vectors
		
	sta insert_instr_tab_cmd_get+2
	sty insert_instr_tab_cmd_get+1
	iny
	sty zp_ed_scr_to_lo+2

	jsr get_instrument_values_vectors
			
	sta insert_instr_tab_val_get+2
	sta insert_instr_tab_val_get_speed+2

	sty insert_instr_tab_val_get+1
	sty insert_instr_tab_val_get_speed+1
	iny
	sty zp_ed_scr_from_lo+2
			


	ldy #$fe		
	cpx #7	;check for speedtable
	bne insert_instr_tab_cmd_get

	ldy #$7e
insert_instr_tab_val_get_speed
	lax adsr_table_value+1,y
	bpl ++
	and #$7f
	cmp zp_ed_scr_to_row+2
	bcc +
	inx
+	
	txa
+	
	sta (zp_ed_scr_from_lo+2),y
	dey
	cpy zp_ed_scr_to_row+2
	bcs insert_instr_tab_val_get_speed
	
	lda #0
	sta (zp_ed_scr_from_lo+2),y
	beq insert_instr_tab_update_pattern_pointers		
		


insert_instr_tab_cmd_get	
	lax adsr_table_cmd+1,y
	sta (zp_ed_scr_to_lo+2),y
insert_instr_tab_val_get	
	lda adsr_table_value+1,y
	cpx #loop
	bne +
	cmp zp_ed_scr_to_row+2
	bcc +
	adc #0
+
	sta (zp_ed_scr_from_lo+2),y
	dey
	cpy zp_ed_scr_to_row+2
	bcs insert_instr_tab_cmd_get
	
	
	jsr back_insert_instr_table_init
-	
	ldy instruments,x
	cpy zp_ed_scr_to_row+2
	bcc +
	inc instruments,x
+	
	sbx #$08
	bcs -
	

insert_instr_tab_update_pattern_pointers
	inc zp_ed_repack_inserts

	lda zp_ed_scr_to_row+2
	sta zp_ed_repack_instrument_value
	
	ldx zp_ed_instrument_prg_current
	lda instrument_tables_driver_commands,x
	sta zp_ed_repack_instrument_command
-
	rts
	
	

	
jump_loop_instr_table_table
	jsr get_instrument_commands_vectors

	ldy current_instr_table_prg_pos,x
	lda (zp_ed_scr_to_lo+2),y
	
	cmp #loop
	bne lock_instr_table_table
	

	
	jsr get_instrument_values_vectors
	ldy current_instr_table_prg_pos,x
	lda (zp_ed_scr_from_lo+2),y
	beq lock_instr_table_table			;dont jump to 0 position
	sta current_instr_table_prg_pos,x
	
	jmp init_instr_table_position	
		
;==========================================================
;enter_selected_table
;
;controls Enter key for each of the 4 editing functions



enter_selected_table

	bit current_editing
	bpl enter_sequencer_or_pattern_table
	bvs enter_instrument_table

	
;======================		
;enter_instr_table_table
	
enter_instr_table_table
	ldy current_instr_table_row
	ldx current_instr_table_column		;#$24;default column hook for all instr table prgs < 6
	
	lda current_instr_table_prg_locked
	eor #1
	sta current_instr_table_prg_locked
	beq enter_instr_table_table_unlocked

		
	cpx #$1e
	lda convert_row_column_to_instr_table_prg,y
	bcc enter_instr_table_table_do
	;increase program to odd value (right side)
	adc #0
	
	ldx #$23
	cpy #$16
	bcc enter_instr_table_table_do
	ldx #$25
	clc

enter_instr_table_table_do	
	inx
	stx current_instr_table_column
	sta zp_ed_instrument_prg_current
	tax
	lda last_instr_table_prg_pos,x 
	adc convert_row_inside_up_instr_table_prg,y
	sta current_instr_table_prg_pos,x  
	rts
	
enter_instr_table_table_unlocked
	;check for loop cmd only for prgs < 6
	
	ldx zp_ed_instrument_prg_current
	cpx #6
	bcc jump_loop_instr_table_table
	
		
lock_instr_table_table
	ldy current_instr_table_row
	ldx current_instr_table_column		;#$24;default column hook for all instr table prgs < 6

	lda #$1d
	cpx #$24
	bcc +
	cpy #$16
	lda #$23
	bcc +
	lda #$25
+	sta current_instr_table_column
	rts
		
;==========================
;enter_instrument_table

enter_instrument_table
	lda current_instrument_row
	eor #1
	tax
	bne +
	
	ldy current_instrument_column
	ldx convert_column_instr_to_table_prg,y
	bpl set_intrument_prg_current
	
	ldx #4
+	sta current_instrument_row
	stx current_instrument_column
instr_prg_value_is_0	
	rts
	
	
set_intrument_prg_current
	
	lda zp_ed_instrument_current
	asl
	asl
	asl
	ora convert_column_instr_to_table_prg,y
	tay
	lda instruments,y
	beq instr_prg_value_is_0
	
	stx zp_ed_instrument_prg_current
	
	sta current_instr_table_prg_pos,x
			
	jsr tab_through_editor_reverse

	jmp init_instr_table_position
	
;========================
				
enter_sequencer_or_pattern_table
	bvs enter_pattern_table
	
		
enter_sequencer_table
	cpx #$1c	;#$e3 XOR #$ff
	beq enter_sequencer_table_current_channel
	ldy #3
	sty zp_ed_scr_temp+2
-	jsr enter_sequencer_table_set_pattern_channel
	inc zp_ed_scr_temp+2
	ldy zp_ed_scr_temp+2
	cpy #6
	bcc -
	
enter_sequencer_table_current_channel
	ldy current_sequencer_row
	jsr enter_sequencer_table_set_pattern_channel
	lda #$80
	sta screen_pattern_rendered
	sta screen_pattern_rendered+7
	sta screen_pattern_rendered+14
	bcs +	
	jmp tab_through_editor
		
	
enter_sequencer_table_set_pattern_channel
	
	jsr get_cursor_value_sequencer
	bcs +
	
	sty current_editing_song_pos,x
		
	lda start_end_scroll_column+7,x
	;c=0
	sbc #5
	sta last_editing_columns+1
	clc
+	rts

	
	
get_cursor_value_sequencer
	ldx mul7-3,y
	stx zp_ed_channel_temp+2
	
	jsr get_song_patterns
	stx zp_ed_scr_from_hi+2
	sta zp_ed_scr_from_lo+2
	
	ldx zp_ed_channel_temp+2
		
	ldy current_sequencer_song_list
	lda (zp_ed_scr_from_lo+2),y

	dey
	pha
	cmp #end
	beq +
	lda (zp_ed_scr_from_lo+2),y
	cmp #loop
	beq +
	clc
	iny
+	pla
enter_sequencer_table_exit	
	rts	

	
	
enter_pattern_table
	txa
	cmp #$1c
	bne +
	eor #$03
+	eor #$7f	;get ENTER/SHFT ENTER for gate
	pha
	
	jsr set_pattern_memory_location
	tay
	
	lda zp_ed_window_open_row
	beq enter_pattern_table_main
	
	eor #$0f
	;c=0 from set_pattern_memory_location
	sbc #4
	tax
	
	pla	;clear
	
	jsr set_pattern_cmd_memory_location
	bcs enter_pattern_table_exit
	
	sta zp_ed_scr_nybble_prehi+2

	jsr init_io_ram
	
	;ldy zp_ed_scr_from_row+2
	lda (zp_ed_scr_from_lo+2),y
	beq enter_pattern_table_exit
	
	stx zp_ed_instrument_prg_current
	
	and zp_ed_scr_nybble_prehi+2
	sta current_instr_table_prg_pos,x
			
	jsr tab_through_editor

init_instr_table_position	
	ldx zp_ed_instrument_prg_current
	lda convert_instr_table_prg_to_row,x
	sta current_instr_table_row
	lda convert_instr_table_prg_to_column,x
	sta current_instr_table_column
init_instr_table_position_lock		
	lda #1
	sta current_instr_table_prg_locked

enter_pattern_table_exit	
	jmp return_io

;----------------------------	
enter_pattern_table_main
		
	txa
	and #$70
	bne enter_pattern_table_cmd_note

	sta zp_ed_scr_from_lo+2
	
;goto instrument
	jsr init_io_ram

	ldy zp_ed_scr_from_row+2
	lda (zp_ed_scr_from_lo+2),y
	and #%00011111
	beq +
	sta zp_ed_instrument_current
	jsr tab_through_editor
	jsr tab_through_editor
	lda #1
	sta current_instrument_column
+
	jmp check_valid_key_pattern_exit-1
	
	
enter_pattern_table_cmd_note	
	cmp #$10
	beq enter_pattern_table_note
	
	txa
	anc #$0f
	tax
	lda start_end_scroll_column+7,x
	sbc #2
	tay
	sty current_pattern_cmd_column	
	iny
	sty current_screen_column
	sty zp_ed_backup_screen	;set flag
	
	jsr make_copy_edit_window

	pla		;clear, dont care about				
	ldx #10
	stx zp_ed_window_open_row
	sec
	jmp open_edit_window
	
enter_pattern_table_note
	jsr init_io_ram
	lda #$80
	sta zp_ed_scr_from_lo+2
	ldy zp_ed_scr_from_row+2
	pla
	jmp check_valid_key_set_value


	
	

	
	
					
;==========================================================
;move_cursor
;
;in: X = $12=up, $11=left, $10=down, $13=right
;in: X = $19=left/up 16 steps, $1b=right/down 16 steps
;IRQ

set_free_play_arpeggiator_speed	
	ldy free_play_arpeggio_speed
	cpx #$12
	bcc +
	iny
	.byte $80	
+	
	dey
	bmi +	
	sty free_play_arpeggio_speed	
+	rts
	
	
move_cursor_song_edit	
	txa
	lsr
	bcc move_cursor_exit
	lsr
	bcs +
	dey	
	bne ++
	rts
+	
	iny
	cpy #17
	bcs move_cursor_exit
+	
	sty zp_ed_song_edit_mode
move_cursor_exit	
	rts


;------------

move_cursor_left
	ldx #$11
	.byte $0c
move_cursor_right
	ldx #$13	
move_cursor
	ldy zp_ed_free_play_mode
	bne set_free_play_arpeggiator_speed	
	ldy zp_ed_song_edit_mode	;also cursor position in song name field	
	bne move_cursor_song_edit

	
move_cursor_main_editing_mode
	lda #1
	sta zp_ed_cursor_move_step
	txa 
	and #$0f
	
	bit current_editing
	bmi +
	jmp move_cursor_sequencer_or_pattern
+	
	bvc move_cursor_instrument_tables

;=============================
;move_cursor_instrument

move_cursor_instrument
	lda current_instrument_column
	ldy current_instrument_row
	beq +
	clc
	adc #25
+	tay
	
-	txa
	lsr
	bcc move_cursor_instrument_up_down
	lsr
	bcc move_cursor_instrument_left
		
	iny
	.byte $80
move_cursor_instrument_left	
	dey
	lda convert_cursor_to_column_instr,y
	bmi -
	sta current_instrument_column 

move_cursor_instrument_up_down	
	rts
	
	
;=============================
;move_cursor_instrument_tables

move_cursor_instrument_tables
	ldx current_instr_table_prg_locked
	php
	
	ldx current_instr_table_column	

	ldy current_instr_table_row
	pha
	and #%00000100
	bne move_cursor_instr_table_up_down_16_steps
	pla
	lsr
	bcc move_cursor_instr_table_up_down
	lsr
	php
	
	cpy #$16
	bcc +
	txa
	sbx #$f3
+
	plp
	bcs move_cursor_instr_table_right
	
	plp
	bne move_cursor_instr_table_left_locked
	
	cpx #$1e
	bcc move_cursor_instr_table_exit
	lda #$1d
	bcs poke_mcitlocked

move_cursor_instr_table_left_locked

	dex
	lda convert_cursor_left_to_column,x
	bcs poke_mcitlocked

			
move_cursor_instr_table_right
	
	plp
	bne move_cursor_instr_table_right_locked

	cpy #$16
	bcc move_cursor_instr_table_right_normal
	
	cpx #$25+12
	bcs move_cursor_instr_table_exit
	lda #$25
	bcc poke_mcitlocked 
		
move_cursor_instr_table_right_normal	
	cpx #$23
	bcs move_cursor_instr_table_exit
	lda #$23
	bcc poke_mcitlocked
	
move_cursor_instr_table_right_locked	
	inx
	lda convert_cursor_right_to_column,x
poke_mcitlocked	sta current_instr_table_column
move_cursor_instr_table_exit
	rts

;====		
	
move_cursor_instr_table_up_down_16_steps
	lda #$10
	sta zp_ed_cursor_move_step
	pla
	eor #$02
	lsr
move_cursor_instr_table_up_down
	lsr
	bcs move_cursor_instr_table_up
	
	plp
	bne move_cursor_instr_table_down_locked

	lda convert_cursor_down_to_row_instr_table+1,y	
	cmp #$16
	bcc set_current_instr_table_row_unlocked
	cpx #$1f
	bcc set_current_instr_table_row_unlocked
	ldy #$25
	bne set_current_instr_table_row_unlocked-2
	
move_cursor_instr_table_down_locked

	lda zp_ed_cursor_move_step
	lsr
	bcc +
	iny	
	lda convert_row_inside_up_instr_table_prg,y
	beq +
	sty current_instr_table_row
+	


	jsr instrument_data_get_program_pos
	clc
	adc zp_ed_cursor_move_step
	pha
	bcs exit_current_instr_table_row_step
	
	sbc convert_row_inside_down_instr_table_prg,y
	clc
	adc instrument_tables_display_rows,x
	bcs exit_current_instr_table_row_step
	
	cmp instrument_tables_max_length,x
	bcs exit_current_instr_table_row_step
	bcc set_current_instr_table_row_step
	
	
	
;====	
move_cursor_instr_table_up

	
	plp
	bne move_cursor_instr_table_up_locked
	
	lda convert_cursor_up_to_row_instr_table-1,y
	cmp #$16
	bcs set_current_instr_table_row_unlocked
	
	cpx #$1f
	bcc set_current_instr_table_row_unlocked
	ldy #$23
	sty current_instr_table_column 
set_current_instr_table_row_unlocked
	sta current_instr_table_row
	rts
	
	
move_cursor_instr_table_up_locked
	lda zp_ed_cursor_move_step
	lsr
	bcc +
	dey
	lda convert_row_inside_down_instr_table_prg,y
	cmp #5
	beq +
	sty current_instr_table_row
+	

	jsr instrument_data_get_program_pos
	sec 
	sbc zp_ed_cursor_move_step		;1
	pha	
	bcc exit_current_instr_table_row_step
	sbc convert_row_inside_up_instr_table_prg,y	;$ff
	beq exit_current_instr_table_row_step
	bcc exit_current_instr_table_row_step

set_current_instr_table_row_step		
	pla	
	sta current_instr_table_prg_pos,x
	.byte $80
exit_current_instr_table_row_step
+	pla
	rts




;=============


	

move_cursor_sequencer_check_nybble
	sty current_sequencer_column
	lda current_sequencer_column_nybble
	eor #1
	sta current_sequencer_column_nybble
	rts


move_cursor_sequencer_or_pattern		
	ldx #$10
	bvs move_cursor_pattern

move_cursor_sequencer

	ldy current_sequencer_column
	lsr
	bcc move_cursor_sequencer_up_down
	lsr
	;bit zp_ed_keyboard_commodore
	
	bcs move_cursor_sequencer_right
	
	lsr
	;lsr
	bcs move_cursor_sequencer_left_16_steps 
		
	dey
	cpy #4
	bcs +
	ldy #6
+	jsr move_cursor_sequencer_check_nybble
	bne ++
	lda current_sequencer_song_list
	beq +
	dec current_sequencer_song_list
+	dec current_sequencer_column	
+	rts

move_cursor_sequencer_right
	lsr
	;lsr
	bcs move_cursor_sequencer_right_16_steps 
	
	iny
	cpy #24
	bcc +
	ldy #21
+	jsr move_cursor_sequencer_check_nybble
	beq ++
	lda current_sequencer_song_list
	cmp #$f7
	bcs +
	inc current_sequencer_song_list
+	inc current_sequencer_column
+	rts
;--------------------------
move_cursor_sequencer_left_16_steps
	stx zp_ed_cursor_move_step
	lda current_sequencer_highest_pos
	sec
	sbc zp_ed_cursor_move_step
	bcc +
	sta current_sequencer_highest_pos
	
	lda current_sequencer_song_list
	;sec
	sbc zp_ed_cursor_move_step
	bcs move_cursor_sequencer_set_16_steps

move_cursor_sequencer_right_16_steps
	txa
	clc
	adc current_sequencer_highest_pos
	bcs +
	cmp #$f2
	bcs +
	sta current_sequencer_highest_pos	
	
	txa
	adc current_sequencer_song_list

move_cursor_sequencer_set_16_steps
	sta current_sequencer_song_list
+	rts

;------------------	
	
move_cursor_sequencer_up_down
	ldy current_sequencer_row
	lsr
	bcc move_cursor_sequencer_up
	
	cpy #4
	bcc ++
	dey
	bcs +
move_cursor_sequencer_up
	
	cpy #5
	bcs ++
	iny
+	sty current_sequencer_row	
+	rts
	

	
;=============================
;move_cursor_pattern

move_cursor_pattern
	lsr
	ldy zp_ed_window_open_row
	beq move_cursor_pattern_row
	
	bcc move_cursor_pattern_cmd_up_down
	lsr
	
	lda ed_sprite_a_0+1
	ora ed_sprite_a_0+3
	ora ed_sprite_a_0+5
	and #$0f

	bcs move_cursor_pattern_cmd_right
	
	cmp #8
	bne +
	dec current_screen_column
+	rts

move_cursor_pattern_cmd_right
	cmp #3
	bne +
	inc current_screen_column
+	rts
	
move_cursor_pattern_cmd_up_down	
	lsr
	bcs move_cursor_pattern_cmd_down
	
	dey
	cpy #3
	bcc +
-	sty zp_ed_window_open_row
+	rts
move_cursor_pattern_cmd_down
	iny
	cpy #11
	bcc -
	rts
		
;move in pattern
	
move_cursor_pattern_row
	ldy current_screen_column
	bcc move_cursor_pattern_up_down
	lsr
	bcs move_cursor_pattern_right
	lsr
	bcc ++
	
	
move_cursor_pattern_left_16_steps
	tya
	sbc #8
	bcs +
	adc #27	
+	tay
+		
	dey
	lda convert_cursor_left_to_column,y
	bne move_cursor_pattern_set_value

			
move_cursor_pattern_right
	lsr
	bcc ++
move_cursor_pattern_right_16_steps
	tya
	adc #7
	cmp #28
	bcc +
	sbc #27	
+	tay
+	
	iny
	lda convert_cursor_right_to_column,y
move_cursor_pattern_set_value	
	sta current_screen_column
	rts	
	
	
;============	
move_cursor_pattern_up_down
	lsr
	bcs move_cursor_pattern_down
	
	lda #1
	sta v1_pattern_speed_timer
	sta v1_pattern_speed_timer+7
	sta v1_pattern_speed_timer+14

jump_move_pattern_up		
	ldx #$0e
-
	lda v1_pattern_speed_timer,x
	cmp #1
	bne jump_move_pattern_up_skip_scroll_screen

					
	lda screen_pattern_position,x
	sbc #11
	cmp screen_pattern_length,x	
	
	lda zp_ed_follow_play_mode
	bcc jump_move_pattern_up_scroll_screen
	beq jump_move_pattern_up_scroll_screen_edit
	
	jsr reset_editor_song_pos
		
	
	lda v123_multi_speed
	bne jump_move_pattern_up_skip_scroll_screen

jump_move_pattern_up_scroll_screen_edit
	jsr copy_screen_buffer_bottom
	
	bne jump_move_pattern_up_skip_scroll_screen
			
jump_move_pattern_up_scroll_screen
;	lda zp_ed_follow_play_mode
	beq jump_move_pattern_up_scroll_screen_
	
	lda v123_multi_speed	
	beq jump_move_pattern_up_scroll_screen_
		
	dec screen_pattern_position,x
	bne jump_move_pattern_up_skip_scroll_screen

jump_move_pattern_up_scroll_screen_	
	;dec $d020
	jsr scroll_pattern_data
	;inc $d020
jump_move_pattern_up_skip_scroll_screen	
	txa
	sbx #7
	bpl -
	
	rts
	
		
;============	
move_cursor_pattern_down
	ldx #$0e
-	
	lda screen_pattern_position,x
	sec
	sbc #13
	bcs move_cursor_down_scroll_screen
	
	lda screen_pattern_length,x
	adc #11
	sta screen_pattern_position,x 
	
	jsr copy_screen_buffer_top
	jmp +
	;bcs +
			
move_cursor_down_scroll_screen

	jsr scroll_pattern_data_init_down
+	
	txa
	sbx #7
	bpl -
-	
	rts

	

	
			
;==========================================================
;free_play
;
free_play_layered_mode
	lda #9
	.byte $0c
free_play_poly_mode
	lda #5
	.byte $0c	
free_play_mono_mode
	lda #1
	sta free_play_mode

	ldy #0
	sty zp_ed_follow_play_mode
	sty zp_ed_song_edit_mode

	cmp #9
	bne +
	
	lda free_play_current_preset
	jsr free_play_init_preset
+	
		
	lda zp_ed_free_play_mode
	bne init_free_play_loop
		
	jsr tab_through_editor_save_params
		
	jsr close_edit_window	;close pattern cmd window	

	jsr make_copy_edit_window	;make backup of current screen state behind window (not needed after closing window, coz state behind previous window = state behind upcoming window)
	
	jsr init_all_channels

init_free_play_loop_instrument
init_free_play_loop_multispeed
init_free_play_loop
	lda #$0f
	jsr editor_init_song
	

	lda #<free_play_loop
	ldy #>free_play_loop
	jmp set_current_editing_routine	

		
free_play_loop	
	jsr editor_play_song

	jsr check_screen_editing_routine

	ldy free_play_mode
	
	ldx zp_ed_free_play_mode
	sty zp_ed_free_play_mode
	bne free_play_update_mode
	
	
	jmp init_free_play_window
	
free_play_update_mode
	
	lda zp_ed_keyboard_current
						
	cpy #5		;poly
	beq +
	
	sta zp_ed_keyboard_current+1
	sta zp_ed_keyboard_current+2
	bcs free_play_skip_intrument_init

+	
	ldx #2
-	lda zp_ed_instrument_current
	cpy #5
	beq +
	cpx free_play_current_channel
	beq +
	lda #0
+	sta free_play_instruments,x
	lda zp_ed_octave
	sta free_play_current_octave,x
	dex
	bpl -


free_play_skip_intrument_init

	jsr free_play_arpeggiator

	
free_play_check_key_off	
	ldx #2
-
	lda free_play_last_key_in_channel,x
	beq ++

	ldy #2
-	
	cmp zp_ed_keyboard_current,y
	beq ++		;last key was found in current key list, skip gate off
	eor #$40		;check also for current shifted version
	cmp zp_ed_keyboard_current,y
	beq ++
	eor #$40		;go back to unshifted
	dey
	bpl -
+	
	ldy mul7,x 
	lda #$fe
	sta v1_channel_and,y

	lda #0
	sta free_play_last_key_in_channel,x
	;sta free_play_last_note_in_channel,x
+
	dex
	bpl --



free_play_check_key_on	
	
	ldx #2
-	
	lda zp_ed_keyboard_current,x
	bmi free_play_key_no_function
	and #$3f		;Use unshifted key
	beq free_play_key_no_function

	cmp #$20
	beq +
	
	ldy zp_ed_free_play_mode
	cpy #5		;not poly mode?
	bne ++
+			
	ldy #2
-	cmp free_play_last_key_in_channel,y
	beq free_play_key_no_function
	dey
	bpl -
+		
	tay

	lda keyboard_notes,y
	beq free_play_key_no_function
			
	jsr free_play_set_note

free_play_key_no_function
	
	dex
	bpl --

	jmp update_free_play_window

free_play_set_note
;in: Y: key
;in: A: note from key
;in: X: key index
	stx free_play_key_index+1
	sty free_play_new_key+1
	sta free_play_new_note+1
	
	ldy #2	
	ldx free_play_current_channel
-	lda free_play_last_key_in_channel,x
	beq free_play_free_slot_for_note
	dex
	bpl +
	ldx #2
+	dey
	bpl -	
	bmi free_play_key_index
	
free_play_free_slot_for_note
	
free_play_new_key
	lda #0
	sta free_play_last_key_in_channel,x

	txa
	asl
	asl
	asl
	asl
	sta zp_ed_scr_to_lo+2
	lda #>free_play_patterns
	sta zp_ed_scr_to_hi+2

	ldy #0	
	lda free_play_instruments,x
	ora #ins00
	sta (zp_ed_scr_to_lo+2),y
	;iny
	;lda #dur00
	;sta (zp_ed_scr_to_lo+2),y	
	
free_play_new_note
	lda #c0
	bmi free_play_cycle_channel
		
	ldy free_play_last_note_in_channel,x
	sta free_play_last_note_in_channel,x
	
	bit free_play_glide_speed
	bmi +	

	pha
	tya
	ldy free_play_current_octave,x
	jsr calculate_play_note	
	ldy #2
	sta (zp_ed_scr_to_lo+2),y
	inc zp_ed_scr_to_lo+2		
	lda #glito
	sta (zp_ed_scr_to_lo+2),y
	lda free_play_glide_speed
	eor #$ff
	sec
	sbc #$9f
	inc zp_ed_scr_to_lo+2	
	sta (zp_ed_scr_to_lo+2),y
	pla
	inc zp_ed_scr_to_lo+2
	
+	
	ldy free_play_current_octave,x
	jsr calculate_play_note
	ldy #2
	sta (zp_ed_scr_to_lo+2),y
	iny
	lda #end
	sta (zp_ed_scr_to_lo+2),y
	
	
	
	ldy mul7,x 
	
	jsr init_free_play_pattern
	
	lda #0
	sta free_play_arpeggiator_speed,x	 
free_play_cycle_channel
		
	dex
	bpl +
	ldx #2
+	stx free_play_current_channel 

free_play_key_index	
	ldx #0
-	jmp return_io

calculate_play_note	
	clc
	adc mul12,y
	sbc #11
	bmi +
	beq +
	cmp #$60
	bcs +
-	
	rts
		
+	pla
	pla
	bne free_play_key_index



cycle_through_presets	;x=$eb XOR $ff = $14
cycle_through_presets_reverse	;x=$ea XOR $ff = $15

	lda zp_ed_free_play_mode
	beq play_base_note	;test instrument
	
	cmp #9		;no function outside layered mode
	bne -
	
	ldy free_play_current_preset
	cpx #$15
	beq +
	iny
	.byte $80
+	dey
	tya
	and #7	
	sta free_play_current_preset
free_play_init_preset
	asl
	asl
	asl
	tay
	
	lda free_play_layered_presets+6,y
	sta free_play_current_multispeed
				
	lda song_pattern_settings_free_play+3
	and #$0f
	ora free_play_current_multispeed
	sta song_pattern_settings_free_play+3

	ldx #0
-	lda free_play_layered_presets,y
	sta free_play_instruments,x
	lda free_play_layered_presets+3,y
	sta free_play_current_octave,x
	iny
	inx
	cpx #3
	bcc -
	jmp init_free_play_loop_multispeed
	

play_base_note
	ldy zp_ed_octave
	lda mul12,y
	clc
	adc zp_ed_note_base
	sta zp_ed_scr_nybble_prehi+2
	
	
	jsr check_mode_convert_column_to_voice_x
	
	jsr play_last_set_note

	ldy #$ff		;force endless, no repeat
	sty zp_ed_keyboard_delay
	jmp return_io
	

free_play_arpeggiator
	lda free_play_arpeggio_type
	beq free_play_arpeggiator_exit
	
	ldx #2
	
free_play_arpeggiator_loop
	
	dec free_play_arpeggiator_speed,x
	bpl free_play_arpeggiator_trigger_exit
	
	lda free_play_arpeggio_speed
	sta free_play_arpeggiator_speed,x
-
	ldy free_play_arpeggiator_pointer,x	
	inc free_play_arpeggiator_pointer,x
	lda free_play_arpeggios+4,y
	bpl ++
	
	cmp #end
	bne +
	ldy free_play_arpeggio_type
	lda free_play_arpeggios,y
	sta free_play_arpeggiator_pointer,x
	bne -	
+
	lda $dc04
	and #3
	tay
	lda mul12,y
+
	ldy mul7,x
	clc
	adc v1_note_base,y
	cmp #$60
	bcc +
	sbc #12
+	sta v1_note_buffer,y
	
			
free_play_arpeggiator_trigger_exit	
	dex
	bpl free_play_arpeggiator_loop
	
free_play_arpeggiator_exit
	rts
		
	
;==============================================	
;tab_through_editor
		
tab_through_editor


	lda #$e8
	.byte $0c	;nop $yyyy
tab_through_editor_reverse
	lda #$ca
	sta tab_through_editor_opcode
	
	
	jsr close_edit_window
	
	jsr tab_through_editor_save_params

tab_through_editor_opcode	
	inx
	lda #3
	sbx #0
	stx tab_editing_index
tab_through_editor_return_params	
	lda last_editing_columns,x
	sta current_editing_columns,x
	lda last_editing_rows,x
	sta current_editing_rows,x
		
	lda last_instr_table_prg_locked
	sta current_instr_table_prg_locked

	lda last_sequencer_highest_pos
	sta current_sequencer_highest_pos	

	lda tab_editing_order,x
	sta current_editing
	
	lda last_editing_song_pos+0
	sta current_editing_song_pos+0
	lda last_editing_song_pos+1
	sta current_editing_song_pos+7
	lda last_editing_song_pos+2
	sta current_editing_song_pos+14
	
	lda last_editing_song
	sta current_editing_song
	
	dec zp_ed_parameters_saved
-
	rts

tab_through_editor_save_params
	lda zp_ed_parameters_saved
	bne -
			
	ldx tab_editing_index	;old index
	lda current_editing_columns,x
	beq + 		;is zero, so idle location
	sta last_editing_columns,x
+	lda current_editing_rows,x
	beq +		;is zero, so idle location
	sta last_editing_rows,x
	lda #0		;set idle location
+	sta current_editing_columns,x

	;sta current_instr_table_prg_locked	

	lda current_instr_table_prg_locked
	sta last_instr_table_prg_locked

	lda current_sequencer_highest_pos
	sta last_sequencer_highest_pos

	lda current_editing
	sta last_editing

	lda current_editing_song_pos+0
	sta last_editing_song_pos+0
	lda current_editing_song_pos+7
	sta last_editing_song_pos+1
	lda current_editing_song_pos+14
	sta last_editing_song_pos+2
	
	
	lda current_editing_song
	sta last_editing_song
	
	inc zp_ed_parameters_saved
	
-	
	rts
			
;check_commodore_key_clipboard
;in: A = $92=up, $91=left, $90=down, $93=right
;in: A = $99=left/up 16 steps, $9b=right/down 16 steps
;in: A = key

check_for_valid_value_key_commodore
	tay
	lda current_editing
	;sty $cffe
	
;	cpy #"."
;	bne +
;	ldx #$1b
;	jmp move_cursor	
;+	cpy #","
;	bne +
;	ldx #$19
;	jmp move_cursor
+	cpy #"+"
	bne +
	jmp set_pattern_length_plus
+	cpy #"-"
	bne +
	jmp set_pattern_length_min
+	cpy #"C"-$40
	beq copy_to_clipboard_init
+	cpy #"X"-$40
	beq cut_to_clipboard_init
	cpy #"V"-$40
	beq paste_from_clipboard_init
	cpy #" "
	bne +	
set_song_data_start_pos	
	ldy current_sequencer_row
	jsr get_cursor_value_sequencer
	bcs +
	lda current_editing_song
	asl
	asl
	adc current_sequencer_row
	;sbc #2
	tay		
	lda current_sequencer_song_list
	sta song_pattern_settings-3,y	
+	rts
	

;-----------------------------------

		
	
paste_from_clipboard_init
	lda #%00000100
	bne +		
cut_to_clipboard_init	
	jsr clipboard_setup_vectors
	lda #%00000010
	bne +
		
copy_to_clipboard_init
	jsr clipboard_setup_vectors
	lda #%00000001
+	ora current_editing
	sta zp_ed_clipboard_copy_paste
	jmp return_io
	
clipboard_setup_vectors
	lda zp_ed_clipboard_copy_paste
	bne +
	lda #$35
	sta $01
	ldy zp_ed_clipboard_marker_start
	ldx zp_ed_clipboard_marker_end	
	bit current_editing
	bmi clipboard_vectors_instrument
	bvs clipboard_vectors_pattern
	
clipboard_vectors_sequencer
	sta $e100+0
	sty $e100+2
	stx $e100+3
	lax current_sequencer_row
	sbx #$03
	stx $e100+1
	rts
clipboard_vectors_pattern
	sta $e108+0
	sty $e108+2
	stx $e108+3
	jsr convert_column_to_voice_x
	stx $e108+1	
	rts
clipboard_vectors_instrument
	bvc clipboard_vectors_instr_data
	sta $e118+0	
	sty $e118+2
	stx $e118+3	
	rts
clipboard_vectors_instr_data
	sta $e110+0
	sty $e110+2
	stx $e110+3
	lda zp_ed_instrument_prg_current
	sta $e110+1
+	rts
	
;=================================	
;---------------------------------	
set_pattern_length_min	
	jsr prepare_new_pattern_length
	dey
	cpy #2
	bcc ++
	sty zp_ed_scr_from_row+2
	sty zp_ed_scr_to_row_end+2
	iny
	bne set_pattern_length_new_value

set_pattern_length_plus
	jsr prepare_new_pattern_length
	iny
	cpy #max_pattern_length+1
	bcs ++
	sty zp_ed_scr_from_row+2
	dey
	sty zp_ed_scr_to_row_end+2
set_pattern_length_new_value


	clc
	ldx #4
-	txa
	adc zp_ed_scr_to_buffer+2
	sta zp_ed_scr_to_hi+2
	lda #0
	sta (zp_ed_scr_to_lo+2),y
	sta zp_ed_scr_to_lo+2
	sta (zp_ed_scr_to_lo+2),y
	lda #$80
	sta zp_ed_scr_to_lo+2
	dex
	bpl -

	ldy zp_ed_scr_from_row+2
;	lda #$80		;set end marker (maybe ora (zp_ed_scr_to_lo+2),y)
	sta (zp_ed_scr_to_lo+2),y
		
	lda zp_ed_scr_to_buffer+2
	sta zp_ed_scr_to_hi+2

	ldx zp_ed_channel_temp+2	
	sty screen_pattern_length,x
	sty depacked_screen_pattern_length,x
	dey
	tya
	ldy zp_ed_channel_temp+2
	cmp pattern_memory_position,x
	bcc +
	jmp update_pattern_screen
	
+	txa
	pha
	jsr update_pattern_screen
	pla
	tax
	jsr scroll_pattern_data_init_down
+	jmp return_io
	
	
	
prepare_new_pattern_length

	jsr prepare_insert_back_space_pattern
	sty zp_ed_scr_to_hi+2
	lda #$80
	sta zp_ed_scr_to_lo+2
	ldx zp_ed_channel_temp+2

	ldy screen_pattern_length,x
	rts
			

	


;==========================================================
;set_screen_and_sprite_values
;This should be seperate functions, but to save some memory & cycles it's one function all together
;
;sets cursor and active line sprites
;sets marker pointers
;checks for channel on/off
;flash cursor
;flash_channel_output

status_convert_routine
	jmp convert_byte_to_text

screen_status_defaults
+	ldx #8
-	lda editor_status_messages,y
	ora #$80
	sta $b41f,x 
	dey
	dex
	bpl -
	rts

set_screen_editing_sprites_values

	lda screen_editing_sprites,y
	pha
	
	lsr
	lsr
	lsr
	lsr
	jsr s_s_e_s_v
	inx	
	pla
	and #$0f
s_s_e_s_v	
	ora #$c0
	sta ed_sprite_a_0,x
	rts
	
	
		
set_screen_and_sprite_values
;--------------------------------------
update_sprite_values
	ldx #1
	lda zp_ed_free_play_mode
	bne set_free_play_sprites

	lda zp_ed_follow_play_mode
	bne set_screen_editing_sprites_play
	
	ldx current_screen_column
set_screen_editing_sprites_play	
	ldy convert_screen_column_to_editing_sprites,x
	ldx #0
-	jsr set_screen_editing_sprites_values
	iny
	;inx	;done in set_screen_editing_sprites_values
	inx
	cpx #6
	bcc -

	lda current_instr_table_column
	beq +
	ldx current_instr_table_row
	cpx #$16
	bcc +
	adc #11
+		
	tax
	ldy convert_screen_column_to_editing_sprites,x
	iny
	iny
	iny
	ldx #6
	jsr set_screen_editing_sprites_values
	
	lda current_instr_table_row
	asl
	asl
	asl
	adc #44
	sta ed_sprite_y_0+6
	sta ed_sprite_y_0+7
		
	
	;lda #%10000000
	;sta ed_sprite_x_hi_+1

	ldx #5
-	lda screen_editing_sprite_x,x
	sta ed_sprite_x_0,x
	lda #140
	sta ed_sprite_y_0,x
	lda #2
	sta ed_sprite_c_0,x
	dex	
	bpl -
	
	sta ed_sprite_c_0+6
	sta ed_sprite_c_0+7
	
	lda #248
	sta ed_sprite_x_0+6
	lda #40
	sta ed_sprite_x_0+7
	
	ldx #%11111111
	ldy #0
	beq set_screen_editing_sprites_x_y_str
		
	
set_free_play_sprites
	inx
-	
	lda free_play_last_key_in_channel,x
	beq +
	lda free_play_last_note_in_channel,x
	sec
	sbc #12
	tay
	bpl ++
+	ldy #0
+	txa
	asl
	tax
	lda free_play_key_sprite_a0,y
	sta ed_sprite_a_0,x
	lda free_play_key_sprite_a1,y
	sta ed_sprite_a_0+1,x
	lda free_play_key_sprite_x,y
	sta ed_sprite_x_0,x
	adc #2
	and #$f0
	sta ed_sprite_x_0+1,x
	lda free_play_key_sprite_c,y
	sta ed_sprite_c_0,x
	sta ed_sprite_c_0+1,x
	lda #146
	sta ed_sprite_y_0,x
	lda #185
	sta ed_sprite_y_0+1,x
	txa
	lsr
	tax
	dex
	bpl -

	ldx #%11000000
	ldy #%00111111	
	sty ed_sprites_flag	
set_screen_editing_sprites_x_y_str
	sty ed_sprite_y_str
	stx ed_sprite_x_str
set_screen_editing_sprites_exit	

;----------------------------
flash_channel_output
	sec	
	ldx #$0e
-	
	txa
	adc #1
	anc #$18
	sta set_output_colour+1
	;c=0
	lda screen_pattern_position,x
	sbc #11
	sta pattern_memory_position,x
	

	ldy zp_ed_follow_play_mode
	beq ++
	
	
	lda v1_channel_and,x
	bpl ++

	ldy current_channel_output,x
		
	lda v1_hard_restart_timer,x
	bmi +
	ldy #$04
	sty current_channel_output,x
+
	dec channel_output_colours_counter,x
	bpl ++

	lda #$02
	sta channel_output_colours_counter,x
	
	dec current_channel_output,x
	bpl ++
+	ldy #0
	sty current_channel_output,x
+

	lda channel_output_colours,y	
set_output_colour
	sta ed_seq_v1_0
	txa
	sbx #$07
	bpl -


;--------------------------------------	
flash_editor_cursor	
	dec screen_editing_sprite_flashing+8
	bpl +
	lda #5
	sta screen_editing_sprite_flashing+8
f_e_c_index	ldx #0
	lda screen_editing_sprite_flashing,x
	sta ed_sprite_mc_0
	dec f_e_c_index+1
	bpl +
	lda #7
	sta f_e_c_index+1
+







;==========================================================
;check_key_and_mute_channel
;
check_key_and_mute_channel
	bit zp_ed_keyboard_commodore
	bpl check_and_mute_channel_exit
	
	jsr get_song_edit_or_free_play_mode
	ora zp_ed_keyboard_speed	
	bne check_and_mute_channel_exit
	
	ldy #4
	ldx #$0e
-	lda editor_mute_keys,y
	cmp zp_ed_keyboard_current
	beq +
	dey
	dey
	txa
	sbx #7
	bpl -
	bmi check_and_mute_channel_exit
+	
	lda follow_play_ch1+1,y
	eor #$ff
	sta follow_play_ch1+1,y
	sta v1_channel_and,x
	and #$80
	ora editor_mute_keys+1,y
	sta zp_ed_pattern_on_off

	
check_and_mute_channel_exit
		
	
	
	
screen_status_message

	lda zp_ed_follow_play_mode
	beq check_screen_status_mode
	
run_clock_timer	
	;jsr screen_status_defaults

	lda #0
	ldx zp_ed_clock_timer_seconds
	ldy zp_ed_clock_timer_frames
	iny
	cpy #50	;PAL
	bcc ++
	tay
	inx
	cpx #60
	bcc +
	tax
	inc zp_ed_clock_timer_minutes	
+	stx zp_ed_clock_timer_seconds
+	sty zp_ed_clock_timer_frames
	

	ldx #2	;in irq	
	
	lda zp_ed_clock_timer_minutes
	jsr convert_byte_to_decimal_text_scr_inverse
;	ora #$80
	sta $b421
	tya
;	ora #$80
	sta $b420
	
	
	lda zp_ed_clock_timer_seconds
	jsr convert_byte_to_decimal_text_scr_inverse
;	ora #$80
	sta $b424
	tya
;	ora #$80
	sta $b423

	lda zp_ed_clock_timer_frames
	asl
	jsr convert_byte_to_decimal_text_scr_inverse
;	lda zp_ed_scr_nybble_lo,x
;	ora #$80
	sta $b427
	tya
;	ora #$80
	sta $b426
	
	lda #":"+$80
	sta $b422
	sta $b425
	
	rts	
	
	
	
	
check_screen_status_mode	
	
	lda zp_ed_free_play_mode
	beq +
	ldy #8
	jmp screen_status_defaults
	
+
	bit zp_ed_keyboard_commodore
	bmi screen_status_message_during_edit
	
	ldy #8
	jsr screen_status_defaults
	ldx #$ff
	lda #0
	beq check_commodore_key_update_marker_set_markers
	
screen_status_message_during_edit
	
	ldy #21
	jsr screen_status_defaults
	lda current_editing
	asl
	rol
	rol
	asl
	tay
	lda clipboard_mark_modes,y
	sta status_convert_routine+1
	lda clipboard_mark_modes+1,y
	sta status_convert_routine+2

;	ldx #2	;status_convert_routine always in irq
	lda zp_ed_clipboard_marker_start
	jsr status_convert_routine

	tya
	ora #$80
	sta $b421
		
	lda zp_ed_scr_nybble_lo,x
	ora #$80
	sta $b422
	
	lda zp_ed_clipboard_marker_end
	jsr status_convert_routine
	
	tya
	ora #$80
	sta $b426
	
	lda zp_ed_scr_nybble_lo,x
	ora #$80
	sta $b427

			
	
;-----------------------------------
check_commodore_key_update_marker

	
	bit current_editing
	bmi check_commodore_key_update_marker_instrument
	bvc check_commodore_key_update_marker_sequencer

	jsr convert_column_to_voice_x
		
	lda pattern_memory_position,x
	jmp check_commodore_key_update_marker_init_pos
	
check_commodore_key_update_marker_sequencer
	lda current_sequencer_song_list	
	jmp check_commodore_key_update_marker_init_pos
	
check_commodore_key_update_marker_instrument
	bvc check_commodore_key_update_marker_instr_data
	
	lda zp_ed_instrument_current
	bne check_commodore_key_update_marker_init_pos
	
check_commodore_key_update_marker_instr_data
	ldy current_instr_table_prg_locked
	beq check_commodore_key_update_marker_set_markers
	
	jsr instrument_data_get_program_pos

check_commodore_key_update_marker_init_pos
	ldx zp_ed_clipboard_marker_start
	cmp zp_ed_clipboard_marker_start
	bcs check_commodore_key_update_marker_set_markers
	tax

check_commodore_key_update_marker_set_markers
	stx zp_ed_clipboard_marker_start
	sta zp_ed_clipboard_marker_end

check_commodore_key_update_marker_exit	
	rts	
	
	
